/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 38 "parser.php7.lemon"

#include "parser.php7.inc.h"

/* Change next line to "#if 1"
 * to enable parser tracing. */
#if 0
# ifdef NDEBUG
#  undef NDEBUG
# endif
#else
# ifndef NDEBUG
#  define NDEBUG 1
# endif
#endif

#line 24 "parser.php7.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    phvolt_TOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is phvolt_TOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    phvolt_ARG_SDECL     A static variable declaration for the %extra_argument
**    phvolt_ARG_PDECL     A parameter declaration for the %extra_argument
**    phvolt_ARG_STORE     Code to store %extra_argument into yypParser
**    phvolt_ARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
#define YYCODETYPE unsigned char
#define YYNOCODE 131
#define YYACTIONTYPE unsigned short int
#define phvolt_TOKENTYPE phvolt_parser_token*
typedef union {
  phvolt_TOKENTYPE yy0;
  zval yy186;
  int yy261;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define phvolt_ARG_SDECL phvolt_parser_status *status;
#define phvolt_ARG_PDECL ,phvolt_parser_status *status
#define phvolt_ARG_FETCH phvolt_parser_status *status = yypParser->status
#define phvolt_ARG_STORE yypParser->status = status
#define YYNSTATE 365
#define YYNRULE 158
#define YYERRORSYMBOL 89
#define YYERRSYMDT yy261
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)

/* Next are that tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N < YYNSTATE                  Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   YYNSTATE <= N < YYNSTATE+YYNRULE   Reduce by rule N-YYNSTATE.
**
**   N == YYNSTATE+YYNRULE              A syntax error has occurred.
**
**   N == YYNSTATE+YYNRULE+1            The parser accepts its input.
**
**   N == YYNSTATE+YYNRULE+2            No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as
**
**      yy_action[ yy_shift_ofst[S] + X ]
**
** If the index value yy_shift_ofst[S]+X is out of range or if the value
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X or if yy_shift_ofst[S]
** is equal to YY_SHIFT_USE_DFLT, it means that the action is not in the table
** and that yy_default[S] should be used instead.  
**
** The formula above is for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array and YY_REDUCE_USE_DFLT is used in place of
** YY_SHIFT_USE_DFLT.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
*/
static YYACTIONTYPE yy_action[] = {
 /*     0 */    95,  111,   63,   55,   57,   85,   69,   65,   67,   75,
 /*    10 */    77,   79,   81,   71,   73,   51,   49,   53,   46,   43,
 /*    20 */    59,   92,   61,   87,   90,   91,   99,   83,  365,  245,
 /*    30 */    87,   90,   91,   99,   83,  300,   51,   49,   53,   46,
 /*    40 */    43,   59,   92,   61,   87,   90,   91,   99,   83,  110,
 /*    50 */   338,  299,  194,  215,  198,   95,  174,   63,   55,   57,
 /*    60 */    85,   69,   65,   67,   75,   77,   79,   81,   71,   73,
 /*    70 */    51,   49,   53,   46,   43,   59,   92,   61,   87,   90,
 /*    80 */    91,   99,   83,  331,  176,   95,   33,   63,   55,   57,
 /*    90 */    85,   69,   65,   67,   75,   77,   79,   81,   71,   73,
 /*   100 */    51,   49,   53,   46,   43,   59,   92,   61,   87,   90,
 /*   110 */    91,   99,   83,   95,  265,   63,   55,   57,   85,   69,
 /*   120 */    65,   67,   75,   77,   79,   81,   71,   73,   51,   49,
 /*   130 */    53,   46,   43,   59,   92,   61,   87,   90,   91,   99,
 /*   140 */    83,  347,  342,   46,   43,   59,   92,   61,   87,   90,
 /*   150 */    91,   99,   83,   35,  266,  197,  198,   39,   95,   88,
 /*   160 */    63,   55,   57,   85,   69,   65,   67,   75,   77,   79,
 /*   170 */    81,   71,   73,   51,   49,   53,   46,   43,   59,   92,
 /*   180 */    61,   87,   90,   91,   99,   83,   95,   29,   63,   55,
 /*   190 */    57,   85,   69,   65,   67,   75,   77,   79,   81,   71,
 /*   200 */    73,   51,   49,   53,   46,   43,   59,   92,   61,   87,
 /*   210 */    90,   91,   99,   83,   95,   42,   63,   55,   57,   85,
 /*   220 */    69,   65,   67,   75,   77,   79,   81,   71,   73,   51,
 /*   230 */    49,   53,   46,   43,   59,   92,   61,   87,   90,   91,
 /*   240 */    99,   83,   92,   61,   87,   90,   91,   99,   83,  321,
 /*   250 */   322,  323,  324,  325,  326,  309,  327,  276,  287,  118,
 /*   260 */   134,   94,  139,  140,  503,   95,   97,   63,   55,   57,
 /*   270 */    85,   69,   65,   67,   75,   77,   79,   81,   71,   73,
 /*   280 */    51,   49,   53,   46,   43,   59,   92,   61,   87,   90,
 /*   290 */    91,   99,   83,   95,  504,   63,   55,   57,   85,   69,
 /*   300 */    65,   67,   75,   77,   79,   81,   71,   73,   51,   49,
 /*   310 */    53,   46,   43,   59,   92,   61,   87,   90,   91,   99,
 /*   320 */    83,  100,  146,  142,  142,  144,  107,  147,  129,  503,
 /*   330 */   504,  318,  107,  120,  137,  109,  145,  116,  120,  141,
 /*   340 */   141,  114,  105,  116,  120,  219,   95,  171,   63,   55,
 /*   350 */    57,   85,   69,   65,   67,   75,   77,   79,   81,   71,
 /*   360 */    73,   51,   49,   53,   46,   43,   59,   92,   61,   87,
 /*   370 */    90,   91,   99,   83,   95,  183,   63,   55,   57,   85,
 /*   380 */    69,   65,   67,   75,   77,   79,   81,   71,   73,   51,
 /*   390 */    49,   53,   46,   43,   59,   92,   61,   87,   90,   91,
 /*   400 */    99,   83,   95,  190,   63,   55,   57,   85,   69,   65,
 /*   410 */    67,   75,   77,   79,   81,   71,   73,   51,   49,   53,
 /*   420 */    46,   43,   59,   92,   61,   87,   90,   91,   99,   83,
 /*   430 */   100,  173,  131,   28,   93,  180,  107,  228,  100,  187,
 /*   440 */   165,  192,  120,  137,  143,  120,  120,  128,  120,  211,
 /*   450 */   120,  132,  120,   95,  213,   63,   55,   57,   85,   69,
 /*   460 */    65,   67,   75,   77,   79,   81,   71,   73,   51,   49,
 /*   470 */    53,   46,   43,   59,   92,   61,   87,   90,   91,   99,
 /*   480 */    83,   95,  130,   63,   55,   57,   85,   69,   65,   67,
 /*   490 */    75,   77,   79,   81,   71,   73,   51,   49,   53,   46,
 /*   500 */    43,   59,   92,   61,   87,   90,   91,   99,   83,  214,
 /*   510 */   262,  217,   95,  254,   63,   55,   57,   85,   69,   65,
 /*   520 */    67,   75,   77,   79,   81,   71,   73,   51,   49,   53,
 /*   530 */    46,   43,   59,   92,   61,   87,   90,   91,   99,   83,
 /*   540 */    95,  268,   63,   55,   57,   85,   69,   65,   67,   75,
 /*   550 */    77,   79,   81,   71,   73,   51,   49,   53,   46,   43,
 /*   560 */    59,   92,   61,   87,   90,   91,   99,   83,   95,  271,
 /*   570 */    63,   55,   57,   85,   69,   65,   67,   75,   77,   79,
 /*   580 */    81,   71,   73,   51,   49,   53,   46,   43,   59,   92,
 /*   590 */    61,   87,   90,   91,   99,   83,   95,  274,   63,   55,
 /*   600 */    57,   85,   69,   65,   67,   75,   77,   79,   81,   71,
 /*   610 */    73,   51,   49,   53,   46,   43,   59,   92,   61,   87,
 /*   620 */    90,   91,   99,   83,   95,  333,   63,   55,   57,   85,
 /*   630 */    69,   65,   67,   75,   77,   79,   81,   71,   73,   51,
 /*   640 */    49,   53,   46,   43,   59,   92,   61,   87,   90,   91,
 /*   650 */    99,   83,   95,  349,   63,   55,   57,   85,   69,   65,
 /*   660 */    67,   75,   77,   79,   81,   71,   73,   51,   49,   53,
 /*   670 */    46,   43,   59,   92,   61,   87,   90,   91,   99,   83,
 /*   680 */    95,  218,   63,   55,   57,   85,   69,   65,   67,   75,
 /*   690 */    77,   79,   81,   71,   73,   51,   49,   53,   46,   43,
 /*   700 */    59,   92,   61,   87,   90,   91,  227,   83,  524,    1,
 /*   710 */     2,  286,    4,    5,    6,    7,    8,    9,   10,   11,
 /*   720 */    12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
 /*   730 */    22,   23,   24,   25,   63,   55,   57,   85,   69,   65,
 /*   740 */    67,   75,   77,   79,   81,   71,   73,   51,   49,   53,
 /*   750 */    46,   43,   59,   92,   61,   87,   90,   91,   99,   83,
 /*   760 */    55,   57,   85,   69,   65,   67,   75,   77,   79,   81,
 /*   770 */    71,   73,   51,   49,   53,   46,   43,   59,   92,   61,
 /*   780 */    87,   90,   91,   99,   83,   30,  286,    4,    5,    6,
 /*   790 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*   800 */    17,   18,   19,   20,   21,   22,   23,   24,   25,   36,
 /*   810 */   286,    4,    5,    6,    7,    8,    9,   10,   11,   12,
 /*   820 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*   830 */    23,   24,   25,  177,  286,    4,    5,    6,    7,    8,
 /*   840 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*   850 */    19,   20,   21,   22,   23,   24,   25,  184,  286,    4,
 /*   860 */     5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
 /*   870 */    15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
 /*   880 */    25,  221,  286,    4,    5,    6,    7,    8,    9,   10,
 /*   890 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*   900 */    21,   22,   23,   24,   25,  231,  286,    4,    5,    6,
 /*   910 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*   920 */    17,   18,   19,   20,   21,   22,   23,   24,   25,  239,
 /*   930 */   286,    4,    5,    6,    7,    8,    9,   10,   11,   12,
 /*   940 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*   950 */    23,   24,   25,  246,  286,    4,    5,    6,    7,    8,
 /*   960 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*   970 */    19,   20,   21,   22,   23,   24,   25,  278,  286,    4,
 /*   980 */     5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
 /*   990 */    15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
 /*  1000 */    25,  289,  286,    4,    5,    6,    7,    8,    9,   10,
 /*  1010 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*  1020 */    21,   22,   23,   24,   25,  295,  286,    4,    5,    6,
 /*  1030 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*  1040 */    17,   18,   19,   20,   21,   22,   23,   24,   25,  312,
 /*  1050 */   286,    4,    5,    6,    7,    8,    9,   10,   11,   12,
 /*  1060 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*  1070 */    23,   24,   25,  334,  286,    4,    5,    6,    7,    8,
 /*  1080 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*  1090 */    19,   20,   21,   22,   23,   24,   25,  343,  286,    4,
 /*  1100 */     5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
 /*  1110 */    15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
 /*  1120 */    25,  350,  286,    4,    5,    6,    7,    8,    9,   10,
 /*  1130 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*  1140 */    21,   22,   23,   24,   25,    3,    4,    5,    6,    7,
 /*  1150 */     8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
 /*  1160 */    18,   19,   20,   21,   22,   23,   24,   25,   27,  235,
 /*  1170 */    32,   34,   40,  170,  172,   41,  196,  181,  169,  188,
 /*  1180 */   191,  193,   45,  168,   48,  220,   50,  120,  216,  224,
 /*  1190 */   120,  230,   52,  111,  120,  120,  120,  225,  120,  234,
 /*  1200 */   256,  236,  293,  243,  120,  250,  195,  260,  263,  237,
 /*  1210 */   269,  272,  275,  238,  282,  284,   85,   69,   65,   67,
 /*  1220 */    75,   77,   79,   81,   71,   73,   51,   49,   53,   46,
 /*  1230 */    43,   59,   92,   61,   87,   90,   91,   99,   83,  255,
 /*  1240 */     4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
 /*  1250 */    14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
 /*  1260 */    24,   25,   27,  235,  358,  360,   40,  170,  172,  366,
 /*  1270 */    26,  181,   26,  188,  191,  193,   54,  357,   56,  115,
 /*  1280 */    58,   60,  216,  242,   62,  249,   64,  131,  120,  316,
 /*  1290 */   120,  225,  120,  120,  251,  236,  120,  243,  120,  250,
 /*  1300 */    66,  260,  263,  257,  269,  272,  275,  258,  282,  284,
 /*  1310 */   119,  277,  120,  281,   27,  235,   38,  306,   40,  170,
 /*  1320 */   172,  283,  120,  181,  285,  188,  191,  193,  288,   68,
 /*  1330 */   292,  252,  294,  252,  216,   31,  298,  229,  252,  310,
 /*  1340 */   354,  120,   37,  225,  178,  437,  328,  236,  259,  243,
 /*  1350 */   259,  250,  438,  260,  263,  259,  269,  272,  275,  303,
 /*  1360 */   282,  284,  305,   69,   65,   67,   75,   77,   79,   81,
 /*  1370 */    71,   73,   51,   49,   53,   46,   43,   59,   92,   61,
 /*  1380 */    87,   90,   91,   99,   83,  307,   27,  235,   70,  308,
 /*  1390 */    40,  170,  172,  311,  179,  181,  252,  188,  191,  193,
 /*  1400 */   120,  252,  315,  252,  244,  252,  216,  252,  319,  185,
 /*  1410 */   318,  222,  317,  259,  330,  225,  120,  320,  259,  236,
 /*  1420 */   259,  243,  259,  250,  259,  260,  263,  232,  269,  272,
 /*  1430 */   275,  301,  282,  284,  337,  339,  340,  346,   27,  235,
 /*  1440 */   209,  353,   40,  170,  172,  356,  212,  181,  186,  188,
 /*  1450 */   191,  193,  359,  240,  253,  361,  332,  362,  216,  290,
 /*  1460 */   363,  199,  201,  203,  205,  207,  120,  225,  120,  364,
 /*  1470 */   252,  236,  252,  243,  247,  250,  290,  260,  263,  279,
 /*  1480 */   269,  272,  275,  290,  282,  284,  290,  259,  252,  259,
 /*  1490 */    27,  235,  252,  290,   40,  170,  172,  290,  296,  181,
 /*  1500 */   290,  188,  191,  193,   72,  259,  290,  290,   74,  259,
 /*  1510 */   216,  290,  223,  290,  252,  290,  120,  290,  290,  225,
 /*  1520 */   120,  290,  290,  236,  290,  243,  290,  250,  290,  260,
 /*  1530 */   263,  259,  269,  272,  275,  252,  282,  284,   76,  290,
 /*  1540 */   252,  290,   27,  235,  252,  290,   40,  170,  172,  290,
 /*  1550 */   120,  181,  259,  188,  191,  193,   78,  259,  290,  252,
 /*  1560 */   290,  259,  216,  290,  290,  290,  290,  290,  120,  290,
 /*  1570 */   290,  225,  233,  290,  290,  236,  259,  243,  313,  250,
 /*  1580 */    80,  260,  263,  335,  269,  272,  275,  344,  282,  284,
 /*  1590 */   290,  290,  120,  290,   27,  235,   82,   84,   40,  170,
 /*  1600 */   172,   86,  351,  181,   89,  188,  191,  193,  120,  120,
 /*  1610 */   290,  290,   96,  120,  216,  290,  120,  290,   98,  290,
 /*  1620 */   102,  290,  290,  225,  120,  290,  290,  236,  241,  243,
 /*  1630 */   120,  250,  120,  260,  263,  290,  269,  272,  275,  252,
 /*  1640 */   282,  284,  104,  290,  252,  290,   27,  235,  252,  290,
 /*  1650 */    40,  170,  172,  290,  120,  181,  259,  188,  191,  193,
 /*  1660 */   135,  259,  290,  252,  167,  259,  216,  290,  290,  290,
 /*  1670 */   290,  290,  120,  290,  290,  225,  120,  290,  290,  236,
 /*  1680 */   259,  243,  248,  250,  290,  260,  263,  290,  269,  272,
 /*  1690 */   275,  290,  282,  284,  175,  290,  182,  290,   27,  235,
 /*  1700 */   189,  200,   40,  170,  172,  202,  120,  181,  120,  188,
 /*  1710 */   191,  193,  120,  120,  204,  290,  206,  120,  216,  290,
 /*  1720 */   208,  290,  210,  290,  226,  290,  120,  225,  120,  290,
 /*  1730 */   290,  236,  120,  243,  120,  250,  120,  260,  263,  290,
 /*  1740 */   269,  272,  275,  280,  282,  284,  261,  290,  264,  290,
 /*  1750 */    27,  235,  290,  267,   40,  170,  172,  270,  120,  181,
 /*  1760 */   120,  188,  191,  193,  273,  120,  290,  290,  341,  120,
 /*  1770 */   216,  290,  348,  290,  290,  290,  120,  290,  290,  225,
 /*  1780 */   120,  290,  290,  236,  120,  243,  290,  250,  290,  260,
 /*  1790 */   263,  290,  269,  272,  275,  291,  282,  284,  290,  290,
 /*  1800 */   290,  290,   27,  235,  290,  290,   40,  170,  172,  290,
 /*  1810 */   290,  181,  290,  188,  191,  193,  290,  290,  290,  290,
 /*  1820 */   290,  290,  216,  290,  290,  290,  290,  290,  290,  290,
 /*  1830 */   290,  225,  290,  290,  290,  236,  290,  243,  297,  250,
 /*  1840 */   290,  260,  263,  290,  269,  272,  275,  290,  282,  284,
 /*  1850 */   290,  290,  290,  290,   27,  235,  290,  290,   40,  170,
 /*  1860 */   172,  290,  290,  181,  290,  188,  191,  193,  290,  290,
 /*  1870 */   290,  290,  290,  290,  216,  290,  290,  290,  290,  290,
 /*  1880 */   290,  290,  290,  225,  290,  290,  290,  236,  302,  243,
 /*  1890 */   290,  250,  290,  260,  263,  290,  269,  272,  275,  290,
 /*  1900 */   282,  284,  290,  290,  290,  290,   27,  235,  290,  290,
 /*  1910 */    40,  170,  172,  290,  290,  181,  290,  188,  191,  193,
 /*  1920 */   290,  290,  290,  290,  290,  290,  216,  290,  314,  290,
 /*  1930 */   290,  290,  290,  290,  290,  225,  290,  290,  290,  236,
 /*  1940 */   290,  243,  290,  250,  290,  260,  263,  290,  269,  272,
 /*  1950 */   275,  290,  282,  284,  290,  290,  290,  290,   27,  235,
 /*  1960 */   290,  290,   40,  170,  172,  290,  290,  181,  329,  188,
 /*  1970 */   191,  193,  290,  290,  290,  290,  290,  290,  216,  290,
 /*  1980 */   290,  290,  290,  290,  290,  290,  290,  225,  290,  290,
 /*  1990 */   290,  236,  290,  243,  290,  250,  290,  260,  263,  290,
 /*  2000 */   269,  272,  275,  290,  282,  284,  290,  290,  290,  290,
 /*  2010 */    27,  235,  290,  290,   40,  170,  172,  290,  336,  181,
 /*  2020 */   290,  188,  191,  193,  290,  290,  290,  290,  290,  290,
 /*  2030 */   216,  290,  290,  290,  290,  290,  290,  290,  290,  225,
 /*  2040 */   290,  290,  290,  236,  290,  243,  290,  250,  290,  260,
 /*  2050 */   263,  290,  269,  272,  275,  290,  282,  284,  290,  290,
 /*  2060 */   290,  290,   27,  235,  290,  290,   40,  170,  172,  290,
 /*  2070 */   345,  181,  290,  188,  191,  193,  290,  290,  290,  290,
 /*  2080 */   290,  290,  216,  290,  290,  290,  290,  290,  290,  290,
 /*  2090 */   290,  225,  290,  290,  290,  236,  290,  243,  290,  250,
 /*  2100 */   290,  260,  263,  290,  269,  272,  275,  290,  282,  284,
 /*  2110 */   290,  290,  290,  290,   27,  235,  290,  290,   40,  170,
 /*  2120 */   172,  290,  352,  181,  290,  188,  191,  193,  290,  290,
 /*  2130 */   290,  290,  290,  290,  216,  290,  290,  290,  290,  290,
 /*  2140 */   290,  290,  290,  225,  290,  290,  290,  236,  290,  243,
 /*  2150 */   290,  250,  290,  260,  263,  290,  269,  272,  275,  290,
 /*  2160 */   282,  284,  290,  290,  290,  290,   27,  235,  355,  290,
 /*  2170 */    40,  170,  172,  290,  290,  181,  290,  188,  191,  193,
 /*  2180 */   290,  290,  290,  290,  290,  290,  216,  290,  290,  290,
 /*  2190 */   290,  290,  290,  290,  290,  225,  290,  290,  290,  236,
 /*  2200 */   290,  243,  290,  250,  290,  260,  263,  290,  269,  272,
 /*  2210 */   275,  290,  282,  284,  290,  290,  290,  290,   27,  235,
 /*  2220 */   290,  290,   40,  170,  172,  290,  290,  181,  290,  188,
 /*  2230 */   191,  193,  290,  290,  290,  290,  290,  290,  216,  290,
 /*  2240 */   290,  290,  290,  290,  290,  290,  290,  225,  290,  290,
 /*  2250 */   290,  236,  290,  243,  290,  250,  290,  260,  263,  290,
 /*  2260 */   269,  272,  275,  290,  282,  284,  290,  290,  290,   47,
 /*  2270 */    44,  290,  106,  290,  101,  290,  290,  103,  290,   47,
 /*  2280 */    44,  290,  106,  290,  101,  290,  121,  103,  290,  290,
 /*  2290 */   290,  290,  290,  290,  290,  290,  121,  290,  290,  290,
 /*  2300 */   290,  290,  122,  123,  124,  125,  126,  127,  290,  290,
 /*  2310 */   290,  290,  122,  123,  124,  125,  126,  127,  290,  290,
 /*  2320 */   290,  290,  290,  290,  290,  290,  290,  290,  157,  158,
 /*  2330 */   159,  160,  161,  162,  163,  112,  290,  290,  150,  151,
 /*  2340 */   152,  153,  154,  155,  156,  112,  290,  290,  166,  290,
 /*  2350 */    47,   44,  290,  106,  290,  101,  138,  164,  103,  290,
 /*  2360 */    47,   44,  290,  106,  290,  101,  290,  121,  103,  290,
 /*  2370 */   290,  290,  290,   47,   44,  290,  106,  121,  101,  290,
 /*  2380 */   290,  103,  290,  122,  123,  124,  125,  126,  127,  290,
 /*  2390 */   149,  290,  290,  122,  123,  124,  125,  126,  127,  290,
 /*  2400 */   290,  290,  290,  290,  290,  290,  148,  123,  124,  125,
 /*  2410 */   126,  127,   47,   44,  290,  106,  112,  101,  290,  290,
 /*  2420 */   103,  290,  290,  290,  290,  290,  112,  290,  290,  121,
 /*  2430 */   290,  290,  290,  290,  290,  290,  290,  290,  290,  112,
 /*  2440 */   290,  290,  290,  136,  290,  122,  133,  124,  125,  126,
 /*  2450 */   127,   47,   44,  290,  106,  290,  101,  290,  290,  103,
 /*  2460 */   290,  290,  290,  290,  290,  290,  290,  290,  121,  290,
 /*  2470 */   290,  290,  290,  290,   47,   44,  290,  106,  112,  101,
 /*  2480 */   108,  290,  103,  290,  122,  117,  124,  125,  126,  127,
 /*  2490 */   290,  121,  290,  290,  290,  290,   47,   44,  290,  106,
 /*  2500 */   290,  101,  290,  290,  103,  290,  290,  122,  117,  124,
 /*  2510 */   125,  126,  127,  121,  290,  290,  290,  112,   47,   44,
 /*  2520 */   290,  106,  290,  101,  290,  290,  103,  304,  290,  122,
 /*  2530 */   133,  124,  125,  126,  127,  121,  290,  290,  290,  290,
 /*  2540 */   112,  113,  290,  290,  290,  290,  290,  290,  290,  290,
 /*  2550 */   290,  122,  123,  124,  125,  126,  127,  290,  290,  290,
 /*  2560 */   290,  290,  112,   47,   44,  290,  106,  290,  101,  290,
 /*  2570 */   290,  103,  290,   47,   44,  290,  106,  290,  101,  290,
 /*  2580 */   121,  103,  290,  290,  112,  290,  290,  290,  290,  290,
 /*  2590 */   121,  290,  290,  290,  290,  290,  122,  117,  124,  125,
 /*  2600 */   126,  127,  290,  290,  290,  290,  122,  133,  124,  125,
 /*  2610 */   126,  127,  290,  290,  290,  290,  290,  290,  290,  290,
 /*  2620 */   290,  290,  290,  290,  290,  290,  290,  290,  290,  112,
 /*  2630 */   290,  290,  290,  290,  290,  290,  290,  290,  290,  112,
};
static YYCODETYPE yy_lookahead[] = {
 /*     0 */     3,    2,    5,    6,    7,    8,    9,   10,   11,   12,
 /*    10 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*    20 */    23,   24,   25,   26,   27,   28,   29,   30,    0,   32,
 /*    30 */    26,   27,   28,   29,   30,   38,   18,   19,   20,   21,
 /*    40 */    22,   23,   24,   25,   26,   27,   28,   29,   30,   50,
 /*    50 */     2,   54,  117,  118,  119,    3,    8,    5,    6,    7,
 /*    60 */     8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
 /*    70 */    18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
 /*    80 */    28,   29,   30,   31,   32,    3,   32,    5,    6,    7,
 /*    90 */     8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
 /*   100 */    18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
 /*   110 */    28,   29,   30,    3,   32,    5,    6,    7,    8,    9,
 /*   120 */    10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
 /*   130 */    20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
 /*   140 */    30,   31,   32,   21,   22,   23,   24,   25,   26,   27,
 /*   150 */    28,   29,   30,   32,   72,  118,  119,   32,    3,    8,
 /*   160 */     5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
 /*   170 */    15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
 /*   180 */    25,   26,   27,   28,   29,   30,    3,   32,    5,    6,
 /*   190 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*   200 */    17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
 /*   210 */    27,   28,   29,   30,    3,   32,    5,    6,    7,    8,
 /*   220 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*   230 */    19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
 /*   240 */    29,   30,   24,   25,   26,   27,   28,   29,   30,   54,
 /*   250 */    55,   56,   57,   58,   59,  120,  121,   58,   59,    4,
 /*   260 */     4,   50,  126,   50,   50,    3,    4,    5,    6,    7,
 /*   270 */     8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
 /*   280 */    18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
 /*   290 */    28,   29,   30,    3,   50,    5,    6,    7,    8,    9,
 /*   300 */    10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
 /*   310 */    20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
 /*   320 */    30,  116,  126,   38,   38,    4,  116,   50,  123,    4,
 /*   330 */     4,   38,  116,  128,  129,  125,   50,  127,  128,   54,
 /*   340 */    54,  125,   52,  127,  128,   52,    3,   32,    5,    6,
 /*   350 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*   360 */    17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
 /*   370 */    27,   28,   29,   30,    3,   32,    5,    6,    7,    8,
 /*   380 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*   390 */    19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
 /*   400 */    29,   30,    3,   32,    5,    6,    7,    8,    9,   10,
 /*   410 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*   420 */    21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
 /*   430 */   116,   38,    2,  116,  116,   32,  116,  123,  116,   32,
 /*   440 */   116,   32,  128,  129,  126,  128,  128,  127,  128,   50,
 /*   450 */   128,  129,  128,    3,   38,    5,    6,    7,    8,    9,
 /*   460 */    10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
 /*   470 */    20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
 /*   480 */    30,    3,   52,    5,    6,    7,    8,    9,   10,   11,
 /*   490 */    12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
 /*   500 */    22,   23,   24,   25,   26,   27,   28,   29,   30,  119,
 /*   510 */    32,   38,    3,   63,    5,    6,    7,    8,    9,   10,
 /*   520 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*   530 */    21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
 /*   540 */     3,   32,    5,    6,    7,    8,    9,   10,   11,   12,
 /*   550 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*   560 */    23,   24,   25,   26,   27,   28,   29,   30,    3,   32,
 /*   570 */     5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
 /*   580 */    15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
 /*   590 */    25,   26,   27,   28,   29,   30,    3,   32,    5,    6,
 /*   600 */     7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
 /*   610 */    17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
 /*   620 */    27,   28,   29,   30,    3,   32,    5,    6,    7,    8,
 /*   630 */     9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
 /*   640 */    19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
 /*   650 */    29,   30,    3,   32,    5,    6,    7,    8,    9,   10,
 /*   660 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*   670 */    21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
 /*   680 */     3,   29,    5,    6,    7,    8,    9,   10,   11,   12,
 /*   690 */    13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
 /*   700 */    23,   24,   25,   26,   27,   28,   29,   30,   90,   91,
 /*   710 */    92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
 /*   720 */   102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
 /*   730 */   112,  113,  114,  115,    5,    6,    7,    8,    9,   10,
 /*   740 */    11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
 /*   750 */    21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
 /*   760 */     6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
 /*   770 */    16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
 /*   780 */    26,   27,   28,   29,   30,   92,   93,   94,   95,   96,
 /*   790 */    97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
 /*   800 */   107,  108,  109,  110,  111,  112,  113,  114,  115,   92,
 /*   810 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*   820 */   103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
 /*   830 */   113,  114,  115,   92,   93,   94,   95,   96,   97,   98,
 /*   840 */    99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
 /*   850 */   109,  110,  111,  112,  113,  114,  115,   92,   93,   94,
 /*   860 */    95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
 /*   870 */   105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
 /*   880 */   115,   92,   93,   94,   95,   96,   97,   98,   99,  100,
 /*   890 */   101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
 /*   900 */   111,  112,  113,  114,  115,   92,   93,   94,   95,   96,
 /*   910 */    97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
 /*   920 */   107,  108,  109,  110,  111,  112,  113,  114,  115,   92,
 /*   930 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*   940 */   103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
 /*   950 */   113,  114,  115,   92,   93,   94,   95,   96,   97,   98,
 /*   960 */    99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
 /*   970 */   109,  110,  111,  112,  113,  114,  115,   92,   93,   94,
 /*   980 */    95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
 /*   990 */   105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
 /*  1000 */   115,   92,   93,   94,   95,   96,   97,   98,   99,  100,
 /*  1010 */   101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
 /*  1020 */   111,  112,  113,  114,  115,   92,   93,   94,   95,   96,
 /*  1030 */    97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
 /*  1040 */   107,  108,  109,  110,  111,  112,  113,  114,  115,   92,
 /*  1050 */    93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
 /*  1060 */   103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
 /*  1070 */   113,  114,  115,   92,   93,   94,   95,   96,   97,   98,
 /*  1080 */    99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
 /*  1090 */   109,  110,  111,  112,  113,  114,  115,   92,   93,   94,
 /*  1100 */    95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
 /*  1110 */   105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
 /*  1120 */   115,   92,   93,   94,   95,   96,   97,   98,   99,  100,
 /*  1130 */   101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
 /*  1140 */   111,  112,  113,  114,  115,   93,   94,   95,   96,   97,
 /*  1150 */    98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
 /*  1160 */   108,  109,  110,  111,  112,  113,  114,  115,   31,   32,
 /*  1170 */    33,   34,   35,   36,   37,  116,    2,   40,  116,   42,
 /*  1180 */    43,   44,  116,  116,  116,   32,  116,  128,   51,   32,
 /*  1190 */   128,   32,  116,    2,  128,  128,  128,   60,  128,   32,
 /*  1200 */     1,   64,  124,   66,  128,   68,   32,   70,   71,   38,
 /*  1210 */    73,   74,   75,   32,   77,   78,    8,    9,   10,   11,
 /*  1220 */    12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
 /*  1230 */    22,   23,   24,   25,   26,   27,   28,   29,   30,   93,
 /*  1240 */    94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
 /*  1250 */   104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
 /*  1260 */   114,  115,   31,   32,   33,   34,   35,   36,   37,    0,
 /*  1270 */     1,   40,    1,   42,   43,   44,  116,    1,  116,   88,
 /*  1280 */   116,  116,   51,   32,  116,   32,  116,    2,  128,    2,
 /*  1290 */   128,   60,  128,  128,   32,   64,  128,   66,  128,   68,
 /*  1300 */   116,   70,   71,   69,   73,   74,   75,   32,   77,   78,
 /*  1310 */   116,   32,  128,   32,   31,   32,   33,    1,   35,   36,
 /*  1320 */    37,   32,  128,   40,   32,   42,   43,   44,   32,  116,
 /*  1330 */    32,   62,   32,   62,   51,    1,   32,   52,   62,   52,
 /*  1340 */     1,  128,    1,   60,    1,   32,    1,   64,   79,   66,
 /*  1350 */    79,   68,   32,   70,   71,   79,   73,   74,   75,   32,
 /*  1360 */    77,   78,   32,    9,   10,   11,   12,   13,   14,   15,
 /*  1370 */    16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
 /*  1380 */    26,   27,   28,   29,   30,   61,   31,   32,  116,   32,
 /*  1390 */    35,   36,   37,   32,   39,   40,   62,   42,   43,   44,
 /*  1400 */   128,   62,   32,   62,  116,   62,   51,   62,   45,    1,
 /*  1410 */    38,    1,  121,   79,   32,   60,  128,  122,   79,   64,
 /*  1420 */    79,   66,   79,   68,   79,   70,   71,    1,   73,   74,
 /*  1430 */    75,    1,   77,   78,   32,   38,    8,   32,   31,   32,
 /*  1440 */    24,   32,   35,   36,   37,   32,   30,   40,   41,   42,
 /*  1450 */    43,   44,   32,    1,  116,   32,  116,    1,   51,  130,
 /*  1460 */    33,   45,   46,   47,   48,   49,  128,   60,  128,   32,
 /*  1470 */    62,   64,   62,   66,    1,   68,  130,   70,   71,    1,
 /*  1480 */    73,   74,   75,    1,   77,   78,  130,   79,   62,   79,
 /*  1490 */    31,   32,   62,  130,   35,   36,   37,  130,    1,   40,
 /*  1500 */   130,   42,   43,   44,  116,   79,  130,  130,  116,   79,
 /*  1510 */    51,  130,   53,  130,   62,  130,  128,  130,  130,   60,
 /*  1520 */   128,  130,  130,   64,  130,   66,  130,   68,  130,   70,
 /*  1530 */    71,   79,   73,   74,   75,   62,   77,   78,  116,  130,
 /*  1540 */    62,  130,   31,   32,   62,  130,   35,   36,   37,  130,
 /*  1550 */   128,   40,   79,   42,   43,   44,  116,   79,  130,   62,
 /*  1560 */   130,   79,   51,  130,  130,  130,  130,  130,  128,  130,
 /*  1570 */   130,   60,   61,  130,  130,   64,   79,   66,    1,   68,
 /*  1580 */   116,   70,   71,    1,   73,   74,   75,    1,   77,   78,
 /*  1590 */   130,  130,  128,  130,   31,   32,  116,  116,   35,   36,
 /*  1600 */    37,  116,    1,   40,  116,   42,   43,   44,  128,  128,
 /*  1610 */   130,  130,  116,  128,   51,  130,  128,  130,  116,  130,
 /*  1620 */   116,  130,  130,   60,  128,  130,  130,   64,   65,   66,
 /*  1630 */   128,   68,  128,   70,   71,  130,   73,   74,   75,   62,
 /*  1640 */    77,   78,  116,  130,   62,  130,   31,   32,   62,  130,
 /*  1650 */    35,   36,   37,  130,  128,   40,   79,   42,   43,   44,
 /*  1660 */   116,   79,  130,   62,  116,   79,   51,  130,  130,  130,
 /*  1670 */   130,  130,  128,  130,  130,   60,  128,  130,  130,   64,
 /*  1680 */    79,   66,   67,   68,  130,   70,   71,  130,   73,   74,
 /*  1690 */    75,  130,   77,   78,  116,  130,  116,  130,   31,   32,
 /*  1700 */   116,  116,   35,   36,   37,  116,  128,   40,  128,   42,
 /*  1710 */    43,   44,  128,  128,  116,  130,  116,  128,   51,  130,
 /*  1720 */   116,  130,  116,  130,  116,  130,  128,   60,  128,  130,
 /*  1730 */   130,   64,  128,   66,  128,   68,  128,   70,   71,  130,
 /*  1740 */    73,   74,   75,   76,   77,   78,  116,  130,  116,  130,
 /*  1750 */    31,   32,  130,  116,   35,   36,   37,  116,  128,   40,
 /*  1760 */   128,   42,   43,   44,  116,  128,  130,  130,  116,  128,
 /*  1770 */    51,  130,  116,  130,  130,  130,  128,  130,  130,   60,
 /*  1780 */   128,  130,  130,   64,  128,   66,  130,   68,  130,   70,
 /*  1790 */    71,  130,   73,   74,   75,   76,   77,   78,  130,  130,
 /*  1800 */   130,  130,   31,   32,  130,  130,   35,   36,   37,  130,
 /*  1810 */   130,   40,  130,   42,   43,   44,  130,  130,  130,  130,
 /*  1820 */   130,  130,   51,  130,  130,  130,  130,  130,  130,  130,
 /*  1830 */   130,   60,  130,  130,  130,   64,  130,   66,   67,   68,
 /*  1840 */   130,   70,   71,  130,   73,   74,   75,  130,   77,   78,
 /*  1850 */   130,  130,  130,  130,   31,   32,  130,  130,   35,   36,
 /*  1860 */    37,  130,  130,   40,  130,   42,   43,   44,  130,  130,
 /*  1870 */   130,  130,  130,  130,   51,  130,  130,  130,  130,  130,
 /*  1880 */   130,  130,  130,   60,  130,  130,  130,   64,   65,   66,
 /*  1890 */   130,   68,  130,   70,   71,  130,   73,   74,   75,  130,
 /*  1900 */    77,   78,  130,  130,  130,  130,   31,   32,  130,  130,
 /*  1910 */    35,   36,   37,  130,  130,   40,  130,   42,   43,   44,
 /*  1920 */   130,  130,  130,  130,  130,  130,   51,  130,   53,  130,
 /*  1930 */   130,  130,  130,  130,  130,   60,  130,  130,  130,   64,
 /*  1940 */   130,   66,  130,   68,  130,   70,   71,  130,   73,   74,
 /*  1950 */    75,  130,   77,   78,  130,  130,  130,  130,   31,   32,
 /*  1960 */   130,  130,   35,   36,   37,  130,  130,   40,   41,   42,
 /*  1970 */    43,   44,  130,  130,  130,  130,  130,  130,   51,  130,
 /*  1980 */   130,  130,  130,  130,  130,  130,  130,   60,  130,  130,
 /*  1990 */   130,   64,  130,   66,  130,   68,  130,   70,   71,  130,
 /*  2000 */    73,   74,   75,  130,   77,   78,  130,  130,  130,  130,
 /*  2010 */    31,   32,  130,  130,   35,   36,   37,  130,   39,   40,
 /*  2020 */   130,   42,   43,   44,  130,  130,  130,  130,  130,  130,
 /*  2030 */    51,  130,  130,  130,  130,  130,  130,  130,  130,   60,
 /*  2040 */   130,  130,  130,   64,  130,   66,  130,   68,  130,   70,
 /*  2050 */    71,  130,   73,   74,   75,  130,   77,   78,  130,  130,
 /*  2060 */   130,  130,   31,   32,  130,  130,   35,   36,   37,  130,
 /*  2070 */    39,   40,  130,   42,   43,   44,  130,  130,  130,  130,
 /*  2080 */   130,  130,   51,  130,  130,  130,  130,  130,  130,  130,
 /*  2090 */   130,   60,  130,  130,  130,   64,  130,   66,  130,   68,
 /*  2100 */   130,   70,   71,  130,   73,   74,   75,  130,   77,   78,
 /*  2110 */   130,  130,  130,  130,   31,   32,  130,  130,   35,   36,
 /*  2120 */    37,  130,   39,   40,  130,   42,   43,   44,  130,  130,
 /*  2130 */   130,  130,  130,  130,   51,  130,  130,  130,  130,  130,
 /*  2140 */   130,  130,  130,   60,  130,  130,  130,   64,  130,   66,
 /*  2150 */   130,   68,  130,   70,   71,  130,   73,   74,   75,  130,
 /*  2160 */    77,   78,  130,  130,  130,  130,   31,   32,   33,  130,
 /*  2170 */    35,   36,   37,  130,  130,   40,  130,   42,   43,   44,
 /*  2180 */   130,  130,  130,  130,  130,  130,   51,  130,  130,  130,
 /*  2190 */   130,  130,  130,  130,  130,   60,  130,  130,  130,   64,
 /*  2200 */   130,   66,  130,   68,  130,   70,   71,  130,   73,   74,
 /*  2210 */    75,  130,   77,   78,  130,  130,  130,  130,   31,   32,
 /*  2220 */   130,  130,   35,   36,   37,  130,  130,   40,  130,   42,
 /*  2230 */    43,   44,  130,  130,  130,  130,  130,  130,   51,  130,
 /*  2240 */   130,  130,  130,  130,  130,  130,  130,   60,  130,  130,
 /*  2250 */   130,   64,  130,   66,  130,   68,  130,   70,   71,  130,
 /*  2260 */    73,   74,   75,  130,   77,   78,  130,  130,  130,   21,
 /*  2270 */    22,  130,   24,  130,   26,  130,  130,   29,  130,   21,
 /*  2280 */    22,  130,   24,  130,   26,  130,   38,   29,  130,  130,
 /*  2290 */   130,  130,  130,  130,  130,  130,   38,  130,  130,  130,
 /*  2300 */   130,  130,   54,   55,   56,   57,   58,   59,  130,  130,
 /*  2310 */   130,  130,   54,   55,   56,   57,   58,   59,  130,  130,
 /*  2320 */   130,  130,  130,  130,  130,  130,  130,  130,   80,   81,
 /*  2330 */    82,   83,   84,   85,   86,   87,  130,  130,   80,   81,
 /*  2340 */    82,   83,   84,   85,   86,   87,  130,  130,   19,  130,
 /*  2350 */    21,   22,  130,   24,  130,   26,    4,   18,   29,  130,
 /*  2360 */    21,   22,  130,   24,  130,   26,  130,   38,   29,  130,
 /*  2370 */   130,  130,  130,   21,   22,  130,   24,   38,   26,  130,
 /*  2380 */   130,   29,  130,   54,   55,   56,   57,   58,   59,  130,
 /*  2390 */    38,  130,  130,   54,   55,   56,   57,   58,   59,  130,
 /*  2400 */   130,  130,  130,  130,  130,  130,   54,   55,   56,   57,
 /*  2410 */    58,   59,   21,   22,  130,   24,   87,   26,  130,  130,
 /*  2420 */    29,  130,  130,  130,  130,  130,   87,  130,  130,   38,
 /*  2430 */   130,  130,  130,  130,  130,  130,  130,  130,  130,   87,
 /*  2440 */   130,  130,  130,   52,  130,   54,   55,   56,   57,   58,
 /*  2450 */    59,   21,   22,  130,   24,  130,   26,  130,  130,   29,
 /*  2460 */   130,  130,  130,  130,  130,  130,  130,  130,   38,  130,
 /*  2470 */   130,  130,  130,  130,   21,   22,  130,   24,   87,   26,
 /*  2480 */    50,  130,   29,  130,   54,   55,   56,   57,   58,   59,
 /*  2490 */   130,   38,  130,  130,  130,  130,   21,   22,  130,   24,
 /*  2500 */   130,   26,  130,  130,   29,  130,  130,   54,   55,   56,
 /*  2510 */    57,   58,   59,   38,  130,  130,  130,   87,   21,   22,
 /*  2520 */   130,   24,  130,   26,  130,  130,   29,   52,  130,   54,
 /*  2530 */    55,   56,   57,   58,   59,   38,  130,  130,  130,  130,
 /*  2540 */    87,   88,  130,  130,  130,  130,  130,  130,  130,  130,
 /*  2550 */   130,   54,   55,   56,   57,   58,   59,  130,  130,  130,
 /*  2560 */   130,  130,   87,   21,   22,  130,   24,  130,   26,  130,
 /*  2570 */   130,   29,  130,   21,   22,  130,   24,  130,   26,  130,
 /*  2580 */    38,   29,  130,  130,   87,  130,  130,  130,  130,  130,
 /*  2590 */    38,  130,  130,  130,  130,  130,   54,   55,   56,   57,
 /*  2600 */    58,   59,  130,  130,  130,  130,   54,   55,   56,   57,
 /*  2610 */    58,   59,  130,  130,  130,  130,  130,  130,  130,  130,
 /*  2620 */   130,  130,  130,  130,  130,  130,  130,  130,  130,   87,
 /*  2630 */   130,  130,  130,  130,  130,  130,  130,  130,  130,   87,
};
#define YY_SHIFT_USE_DFLT (-4)
static short yy_shift_ofst[] = {
 /*     0 */  1271,   28, 1269,   -4,   -4,   -4,   -4,   -4,   -4,   -4,
 /*    10 */    -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,
 /*    20 */    -4,   -4,   -4,   -4,   -4,   -4, 2187, 2497,  155, 1276,
 /*    30 */  1334, 1137,   54,   -4,  121, 1339, 1341, 1283,  125,   -4,
 /*    40 */  2497,  183,   -4, 2497, 2497,  218, 2497, 2497,  218, 2329,
 /*    50 */   122, 2339,  122, 2497,  122, 2497, 1208, 2497, 1208, 2497,
 /*    60 */   218, 2497,    4, 2497,  754, 2497,   18, 2248,   18, 2258,
 /*    70 */    18, 2497,   18, 2497,   18, 2497,   18, 2497,   18, 2497,
 /*    80 */    18, 2497,   18, 2497,   -4, 2497, 1354,  151, 2497,    4,
 /*    90 */    -4,   -4, 2352,  211,   -4, 2497,  262, 2497,  729, 2391,
 /*   100 */   649, 2497,    4, 2497,  290,   -4, 2430,  649,   -4,   -1,
 /*   110 */    -4, 2542, 2453,   -4, 1191,   -4,   -4,  255, 2497,  649,
 /*   120 */    -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,  430,
 /*   130 */    -4, 2552,   -4,  256, 2497,  649,   -4,   -4,  285,  213,
 /*   140 */    -4,  214,  244,  321,  286,   -4,  277,   -4,  325,  326,
 /*   150 */    -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4,
 /*   160 */    -4,   -4,   -4,   -4, 2497,  122, 2497,  122,  218,  218,
 /*   170 */   315,   -4,  393,   48, 2497,   52, 1271, 1343, 1355,  403,
 /*   180 */    -4, 2497,  343, 1345, 1408, 1407,  407,   -4, 2497,  371,
 /*   190 */    -4,  409,   -4,  416, 1174,   -4,  416,   -4, 1416, 2497,
 /*   200 */   649, 2497,  649, 2497,  649, 2497,  649, 2497,  649, 2497,
 /*   210 */   399,   -4,  416,   -4,   -4,   -4,  473,  652,  293, 1153,
 /*   220 */  1271, 1410, 1459, 1157,   -4, 2497,  677, 2475, 1285, 1159,
 /*   230 */  1271, 1426, 1511, 1167,   -4,   -4, 1171, 1181, 1430, 1452,
 /*   240 */  1563, 1251,   -4, 2497,   -3, 1271, 1473, 1615, 1253,   -4,
 /*   250 */  1262, 1271, 2497,  450,   -4, 1199, 1234, 1275,   -4,   -4,
 /*   260 */  2497,  478,   -4, 2497,   82,   -4, 2497,  509,   -4, 2497,
 /*   270 */   537,   -4, 2497,  565,   -4,  199, 1279, 1271, 1478, 1667,
 /*   280 */  1281,   -4, 1289,   -4, 1292,   -4,   -4, 1296, 1271, 1482,
 /*   290 */  1719, 1298,   -4, 1300, 1271, 1497, 1771, 1304,   -4, 1313,
 /*   300 */  1320, 1823, 1327,   -4, 1330, 1316, 1324, 1357,   -4, 1287,
 /*   310 */  1361, 1271, 1577, 1875, 1370,   -4, 1372,   -4, 1363,  195,
 /*   320 */    -4,   -4,   -4,   -4,   -4,   -4,   -4,   -4, 1927, 1382,
 /*   330 */    -4, 2497,  593, 1271, 1582, 1979, 1402,   -4, 1397, 1428,
 /*   340 */  2497,  110, 1271, 1586, 2031, 1405,   -4, 2497,  621, 1271,
 /*   350 */  1601, 2083, 1409,   -4, 2135, 1413,   -4, 1231, 1420,   -4,
 /*   360 */  1423, 1456, 1427, 1437,   -4,
};
#define YY_REDUCE_USE_DFLT (-66)
static short yy_reduce_ofst[] = {
 /*     0 */   618,  -66, 1052,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*    10 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*    20 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  317,  -66,  693,
 /*    30 */  1052,  -66,  -66,  -66,  -66,  717, 1052,  -66,  -66,  -66,
 /*    40 */  1059,  -66,  -66, 1062, 1066,  -66, 1067, 1068,  -66, 1070,
 /*    50 */   -66, 1076,  -66, 1160,  -66, 1162,  -66, 1164,  -66, 1165,
 /*    60 */   -66, 1168,  -66, 1170,  -66, 1184,  -66, 1213,  -66, 1272,
 /*    70 */   -66, 1388,  -66, 1392,  -66, 1422,  -66, 1440,  -66, 1464,
 /*    80 */   -66, 1480,  -66, 1481,  -66, 1485,  -66,  -66, 1488,  -66,
 /*    90 */   -66,  -66,  318,  -66,  -66, 1496,  -66, 1502,  -66,  205,
 /*   100 */   -66, 1504,  -66, 1526,  -66,  -66,  210,  -66,  -66,  -66,
 /*   110 */   -66,  320,  216,  -66,  -66,  -66,  -66,  -66, 1194,  -66,
 /*   120 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   130 */   -66,  322,  -66,  -66, 1544,  -66,  -66,  -66,  136,  -66,
 /*   140 */   -66,  -66,  -66,  -66,  196,  -66,  -66,  -66,  -66,  -66,
 /*   150 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   160 */   -66,  -66,  -66,  -66,  324,  -66, 1548,  -66,  -66,  -66,
 /*   170 */   -66,  -66,  -66,  -66, 1578,  -66,  741, 1052,  -66,  -66,
 /*   180 */   -66, 1580,  -66,  765, 1052,  -66,  -66,  -66, 1584,  -66,
 /*   190 */   -66,  -66,  -66,  -65,  -66,  -66,   37,  -66,  -66, 1585,
 /*   200 */   -66, 1589,  -66, 1598,  -66, 1600,  -66, 1604,  -66, 1606,
 /*   210 */   -66,  -66,  390,  -66,  -66,  -66,  -66,  -66,  135,  -66,
 /*   220 */   789, 1052,  -66,  -66,  -66, 1608,  -66,  314,  -66,  -66,
 /*   230 */   813, 1052,  -66,  -66,  -66,  -66,  -66,  -66,  837, 1052,
 /*   240 */   -66,  -66,  -66, 1288, 1078,  861, 1052,  -66,  -66,  -66,
 /*   250 */   -66, 1146, 1338,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   260 */  1630,  -66,  -66, 1632,  -66,  -66, 1637,  -66,  -66, 1641,
 /*   270 */   -66,  -66, 1648,  -66,  -66,  -66,  -66,  885, 1052,  -66,
 /*   280 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  909, 1052,
 /*   290 */   -66,  -66,  -66,  -66,  933, 1052,  -66,  -66,  -66,  -66,
 /*   300 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   310 */   -66,  957, 1052,  -66,  -66,  -66, 1291,  -66,  -66, 1295,
 /*   320 */   -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   330 */   -66, 1340,  -66,  981, 1052,  -66,  -66,  -66,  -66,  -66,
 /*   340 */  1652,  -66, 1005, 1052,  -66,  -66,  -66, 1656,  -66, 1029,
 /*   350 */  1052,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,  -66,
 /*   360 */   -66,  -66,  -66,  -66,  -66,
};
static YYACTIONTYPE yy_default[] = {
 /*     0 */   523,  523,  523,  367,  369,  370,  371,  372,  373,  374,
 /*    10 */   375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
 /*    20 */   385,  386,  387,  388,  389,  390,  523,  523,  523,  523,
 /*    30 */   523,  523,  523,  391,  523,  523,  523,  523,  523,  393,
 /*    40 */   523,  523,  396,  523,  523,  450,  523,  523,  451,  523,
 /*    50 */   454,  523,  456,  523,  458,  523,  459,  523,  460,  523,
 /*    60 */   461,  523,  462,  523,  463,  523,  464,  523,  480,  523,
 /*    70 */   479,  523,  481,  523,  482,  523,  483,  523,  484,  523,
 /*    80 */   485,  523,  486,  523,  487,  523,  488,  523,  523,  489,
 /*    90 */   491,  492,  523,  523,  498,  523,  523,  523,  499,  523,
 /*   100 */   514,  523,  490,  523,  523,  493,  523,  508,  494,  523,
 /*   110 */   495,  523,  523,  496,  523,  497,  506,  518,  523,  507,
 /*   120 */   509,  516,  517,  518,  519,  520,  521,  522,  505,  523,
 /*   130 */   510,  523,  512,  518,  523,  515,  511,  513,  523,  523,
 /*   140 */   500,  523,  523,  523,  523,  501,  523,  502,  517,  516,
 /*   150 */   466,  468,  470,  472,  474,  476,  478,  465,  467,  469,
 /*   160 */   471,  473,  475,  477,  523,  457,  523,  455,  453,  452,
 /*   170 */   523,  397,  523,  523,  523,  523,  523,  523,  523,  523,
 /*   180 */   398,  523,  523,  523,  523,  523,  523,  402,  523,  523,
 /*   190 */   404,  523,  405,  523,  523,  406,  523,  407,  523,  523,
 /*   200 */   409,  523,  410,  523,  411,  523,  412,  523,  413,  523,
 /*   210 */   523,  415,  523,  414,  416,  408,  523,  523,  523,  523,
 /*   220 */   523,  523,  523,  523,  417,  523,  523,  523,  523,  510,
 /*   230 */   523,  523,  523,  523,  429,  431,  523,  523,  523,  523,
 /*   240 */   523,  523,  433,  523,  523,  523,  523,  523,  523,  435,
 /*   250 */   523,  523,  523,  523,  432,  523,  523,  523,  439,  449,
 /*   260 */   523,  523,  440,  523,  523,  441,  523,  523,  442,  523,
 /*   270 */   523,  443,  523,  523,  444,  523,  523,  523,  523,  523,
 /*   280 */   523,  445,  523,  447,  523,  448,  368,  523,  523,  523,
 /*   290 */   523,  523,  446,  523,  523,  523,  523,  523,  436,  523,
 /*   300 */   523,  523,  523,  434,  511,  523,  523,  523,  430,  523,
 /*   310 */   523,  523,  523,  523,  523,  418,  523,  419,  421,  523,
 /*   320 */   422,  423,  424,  425,  426,  427,  428,  420,  523,  523,
 /*   330 */   403,  523,  523,  523,  523,  523,  523,  399,  523,  523,
 /*   340 */   523,  523,  523,  523,  523,  523,  400,  523,  523,  523,
 /*   350 */   523,  523,  523,  401,  523,  523,  394,  523,  523,  392,
 /*   360 */   523,  523,  523,  523,  395,
};
#define YY_SZ_ACTTAB (sizeof(yy_action)/sizeof(yy_action[0]))

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  phvolt_ARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void phvolt_Trace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *yyTokenName[] = { 
  "$",             "OPEN_DELIMITER",  "COMMA",         "QUESTION",    
  "COLON",         "RANGE",         "AND",           "OR",          
  "IN",            "IS",            "EQUALS",        "NOTEQUALS",   
  "LESS",          "GREATER",       "GREATEREQUAL",  "LESSEQUAL",   
  "IDENTICAL",     "NOTIDENTICAL",  "DIVIDE",        "TIMES",       
  "MOD",           "PLUS",          "MINUS",         "CONCAT",      
  "SBRACKET_OPEN",  "PIPE",          "NOT",           "INCR",        
  "DECR",          "PARENTHESES_OPEN",  "DOT",           "IF",          
  "CLOSE_DELIMITER",  "ENDIF",         "ELSE",          "ELSEIF",      
  "ELSEFOR",       "FOR",           "IDENTIFIER",    "ENDFOR",      
  "SWITCH",        "ENDSWITCH",     "CASE",          "DEFAULT",     
  "SET",           "ASSIGN",        "ADD_ASSIGN",    "SUB_ASSIGN",  
  "MUL_ASSIGN",    "DIV_ASSIGN",    "SBRACKET_CLOSE",  "MACRO",       
  "PARENTHESES_CLOSE",  "ENDMACRO",      "INTEGER",       "STRING",      
  "DOUBLE",        "NULL",          "FALSE",         "TRUE",        
  "CALL",          "ENDCALL",       "OPEN_EDELIMITER",  "CLOSE_EDELIMITER",
  "BLOCK",         "ENDBLOCK",      "CACHE",         "ENDCACHE",    
  "RAW",           "ENDRAW",        "EXTENDS",       "INCLUDE",     
  "WITH",          "DO",            "RETURN",        "AUTOESCAPE",  
  "ENDAUTOESCAPE",  "BREAK",         "CONTINUE",      "RAW_FRAGMENT",
  "DEFINED",       "EMPTY",         "EVEN",          "ODD",         
  "NUMERIC",       "SCALAR",        "ITERABLE",      "CBRACKET_OPEN",
  "CBRACKET_CLOSE",  "error",         "program",       "volt_language",
  "statement_list",  "statement",     "raw_fragment",  "if_statement",
  "elseif_statement",  "elsefor_statement",  "for_statement",  "switch_statement",
  "case_clause",   "set_statement",  "echo_statement",  "block_statement",
  "cache_statement",  "extends_statement",  "include_statement",  "do_statement",
  "return_statement",  "autoescape_statement",  "raw_statement",  "break_statement",
  "continue_statement",  "macro_statement",  "empty_statement",  "macro_call_statement",
  "expr",          "set_assignments",  "set_assignment",  "assignable_expr",
  "macro_parameters",  "macro_parameter",  "macro_parameter_default",  "argument_list",
  "cache_lifetime",  "array_list",    "slice_offset",  "array_item",  
  "function_call",  "argument_item",
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *yyRuleName[] = {
 /*   0 */ "program ::= volt_language",
 /*   1 */ "volt_language ::= statement_list",
 /*   2 */ "statement_list ::= statement_list statement",
 /*   3 */ "statement_list ::= statement",
 /*   4 */ "statement ::= raw_fragment",
 /*   5 */ "statement ::= if_statement",
 /*   6 */ "statement ::= elseif_statement",
 /*   7 */ "statement ::= elsefor_statement",
 /*   8 */ "statement ::= for_statement",
 /*   9 */ "statement ::= switch_statement",
 /*  10 */ "statement ::= case_clause",
 /*  11 */ "statement ::= set_statement",
 /*  12 */ "statement ::= echo_statement",
 /*  13 */ "statement ::= block_statement",
 /*  14 */ "statement ::= cache_statement",
 /*  15 */ "statement ::= extends_statement",
 /*  16 */ "statement ::= include_statement",
 /*  17 */ "statement ::= do_statement",
 /*  18 */ "statement ::= return_statement",
 /*  19 */ "statement ::= autoescape_statement",
 /*  20 */ "statement ::= raw_statement",
 /*  21 */ "statement ::= break_statement",
 /*  22 */ "statement ::= continue_statement",
 /*  23 */ "statement ::= macro_statement",
 /*  24 */ "statement ::= empty_statement",
 /*  25 */ "statement ::= macro_call_statement",
 /*  26 */ "if_statement ::= OPEN_DELIMITER IF expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDIF CLOSE_DELIMITER",
 /*  27 */ "if_statement ::= OPEN_DELIMITER IF expr CLOSE_DELIMITER OPEN_DELIMITER ENDIF CLOSE_DELIMITER",
 /*  28 */ "if_statement ::= OPEN_DELIMITER IF expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ELSE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDIF CLOSE_DELIMITER",
 /*  29 */ "if_statement ::= OPEN_DELIMITER IF expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ELSE CLOSE_DELIMITER OPEN_DELIMITER ENDIF CLOSE_DELIMITER",
 /*  30 */ "if_statement ::= OPEN_DELIMITER IF expr CLOSE_DELIMITER OPEN_DELIMITER ELSE CLOSE_DELIMITER OPEN_DELIMITER ENDIF CLOSE_DELIMITER",
 /*  31 */ "elseif_statement ::= OPEN_DELIMITER ELSEIF expr CLOSE_DELIMITER",
 /*  32 */ "elsefor_statement ::= OPEN_DELIMITER ELSEFOR CLOSE_DELIMITER",
 /*  33 */ "for_statement ::= OPEN_DELIMITER FOR IDENTIFIER IN expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDFOR CLOSE_DELIMITER",
 /*  34 */ "for_statement ::= OPEN_DELIMITER FOR IDENTIFIER IN expr IF expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDFOR CLOSE_DELIMITER",
 /*  35 */ "for_statement ::= OPEN_DELIMITER FOR IDENTIFIER COMMA IDENTIFIER IN expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDFOR CLOSE_DELIMITER",
 /*  36 */ "for_statement ::= OPEN_DELIMITER FOR IDENTIFIER COMMA IDENTIFIER IN expr IF expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDFOR CLOSE_DELIMITER",
 /*  37 */ "switch_statement ::= OPEN_DELIMITER SWITCH expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDSWITCH CLOSE_DELIMITER",
 /*  38 */ "switch_statement ::= OPEN_DELIMITER SWITCH expr CLOSE_DELIMITER OPEN_DELIMITER ENDSWITCH CLOSE_DELIMITER",
 /*  39 */ "case_clause ::= OPEN_DELIMITER CASE expr CLOSE_DELIMITER",
 /*  40 */ "case_clause ::= OPEN_DELIMITER DEFAULT CLOSE_DELIMITER",
 /*  41 */ "set_statement ::= OPEN_DELIMITER SET set_assignments CLOSE_DELIMITER",
 /*  42 */ "set_assignments ::= set_assignments COMMA set_assignment",
 /*  43 */ "set_assignments ::= set_assignment",
 /*  44 */ "set_assignment ::= assignable_expr ASSIGN expr",
 /*  45 */ "set_assignment ::= assignable_expr ADD_ASSIGN expr",
 /*  46 */ "set_assignment ::= assignable_expr SUB_ASSIGN expr",
 /*  47 */ "set_assignment ::= assignable_expr MUL_ASSIGN expr",
 /*  48 */ "set_assignment ::= assignable_expr DIV_ASSIGN expr",
 /*  49 */ "assignable_expr ::= IDENTIFIER",
 /*  50 */ "assignable_expr ::= assignable_expr SBRACKET_OPEN expr SBRACKET_CLOSE",
 /*  51 */ "assignable_expr ::= assignable_expr DOT assignable_expr",
 /*  52 */ "macro_statement ::= OPEN_DELIMITER MACRO IDENTIFIER PARENTHESES_OPEN PARENTHESES_CLOSE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDMACRO CLOSE_DELIMITER",
 /*  53 */ "macro_statement ::= OPEN_DELIMITER MACRO IDENTIFIER PARENTHESES_OPEN macro_parameters PARENTHESES_CLOSE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDMACRO CLOSE_DELIMITER",
 /*  54 */ "macro_parameters ::= macro_parameters COMMA macro_parameter",
 /*  55 */ "macro_parameters ::= macro_parameter",
 /*  56 */ "macro_parameter ::= IDENTIFIER",
 /*  57 */ "macro_parameter ::= IDENTIFIER ASSIGN macro_parameter_default",
 /*  58 */ "macro_parameter_default ::= INTEGER",
 /*  59 */ "macro_parameter_default ::= STRING",
 /*  60 */ "macro_parameter_default ::= DOUBLE",
 /*  61 */ "macro_parameter_default ::= NULL",
 /*  62 */ "macro_parameter_default ::= FALSE",
 /*  63 */ "macro_parameter_default ::= TRUE",
 /*  64 */ "macro_call_statement ::= OPEN_DELIMITER CALL expr PARENTHESES_OPEN argument_list PARENTHESES_CLOSE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDCALL CLOSE_DELIMITER",
 /*  65 */ "macro_call_statement ::= OPEN_DELIMITER CALL expr PARENTHESES_OPEN PARENTHESES_CLOSE CLOSE_DELIMITER OPEN_DELIMITER ENDCALL CLOSE_DELIMITER",
 /*  66 */ "empty_statement ::= OPEN_DELIMITER CLOSE_DELIMITER",
 /*  67 */ "echo_statement ::= OPEN_EDELIMITER expr CLOSE_EDELIMITER",
 /*  68 */ "block_statement ::= OPEN_DELIMITER BLOCK IDENTIFIER CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDBLOCK CLOSE_DELIMITER",
 /*  69 */ "block_statement ::= OPEN_DELIMITER BLOCK IDENTIFIER CLOSE_DELIMITER OPEN_DELIMITER ENDBLOCK CLOSE_DELIMITER",
 /*  70 */ "cache_statement ::= OPEN_DELIMITER CACHE expr CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDCACHE CLOSE_DELIMITER",
 /*  71 */ "cache_statement ::= OPEN_DELIMITER CACHE expr cache_lifetime CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDCACHE CLOSE_DELIMITER",
 /*  72 */ "cache_lifetime ::= INTEGER",
 /*  73 */ "cache_lifetime ::= IDENTIFIER",
 /*  74 */ "raw_statement ::= OPEN_DELIMITER RAW CLOSE_DELIMITER statement OPEN_DELIMITER ENDRAW CLOSE_DELIMITER",
 /*  75 */ "extends_statement ::= OPEN_DELIMITER EXTENDS expr CLOSE_DELIMITER",
 /*  76 */ "include_statement ::= OPEN_DELIMITER INCLUDE expr CLOSE_DELIMITER",
 /*  77 */ "include_statement ::= OPEN_DELIMITER INCLUDE expr WITH expr CLOSE_DELIMITER",
 /*  78 */ "do_statement ::= OPEN_DELIMITER DO expr CLOSE_DELIMITER",
 /*  79 */ "return_statement ::= OPEN_DELIMITER RETURN expr CLOSE_DELIMITER",
 /*  80 */ "autoescape_statement ::= OPEN_DELIMITER AUTOESCAPE FALSE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDAUTOESCAPE CLOSE_DELIMITER",
 /*  81 */ "autoescape_statement ::= OPEN_DELIMITER AUTOESCAPE TRUE CLOSE_DELIMITER statement_list OPEN_DELIMITER ENDAUTOESCAPE CLOSE_DELIMITER",
 /*  82 */ "break_statement ::= OPEN_DELIMITER BREAK CLOSE_DELIMITER",
 /*  83 */ "continue_statement ::= OPEN_DELIMITER CONTINUE CLOSE_DELIMITER",
 /*  84 */ "raw_fragment ::= RAW_FRAGMENT",
 /*  85 */ "expr ::= MINUS expr",
 /*  86 */ "expr ::= PLUS expr",
 /*  87 */ "expr ::= expr MINUS expr",
 /*  88 */ "expr ::= expr PLUS expr",
 /*  89 */ "expr ::= expr TIMES expr",
 /*  90 */ "expr ::= expr TIMES TIMES expr",
 /*  91 */ "expr ::= expr DIVIDE expr",
 /*  92 */ "expr ::= expr DIVIDE DIVIDE expr",
 /*  93 */ "expr ::= expr MOD expr",
 /*  94 */ "expr ::= expr AND expr",
 /*  95 */ "expr ::= expr OR expr",
 /*  96 */ "expr ::= expr CONCAT expr",
 /*  97 */ "expr ::= expr PIPE expr",
 /*  98 */ "expr ::= expr RANGE expr",
 /*  99 */ "expr ::= expr EQUALS expr",
 /* 100 */ "expr ::= expr NOTEQUALS DEFINED",
 /* 101 */ "expr ::= expr IS DEFINED",
 /* 102 */ "expr ::= expr NOTEQUALS EMPTY",
 /* 103 */ "expr ::= expr IS EMPTY",
 /* 104 */ "expr ::= expr NOTEQUALS EVEN",
 /* 105 */ "expr ::= expr IS EVEN",
 /* 106 */ "expr ::= expr NOTEQUALS ODD",
 /* 107 */ "expr ::= expr IS ODD",
 /* 108 */ "expr ::= expr NOTEQUALS NUMERIC",
 /* 109 */ "expr ::= expr IS NUMERIC",
 /* 110 */ "expr ::= expr NOTEQUALS SCALAR",
 /* 111 */ "expr ::= expr IS SCALAR",
 /* 112 */ "expr ::= expr NOTEQUALS ITERABLE",
 /* 113 */ "expr ::= expr IS ITERABLE",
 /* 114 */ "expr ::= expr IS expr",
 /* 115 */ "expr ::= expr NOTEQUALS expr",
 /* 116 */ "expr ::= expr IDENTICAL expr",
 /* 117 */ "expr ::= expr NOTIDENTICAL expr",
 /* 118 */ "expr ::= expr LESS expr",
 /* 119 */ "expr ::= expr GREATER expr",
 /* 120 */ "expr ::= expr GREATEREQUAL expr",
 /* 121 */ "expr ::= expr LESSEQUAL expr",
 /* 122 */ "expr ::= expr DOT expr",
 /* 123 */ "expr ::= expr IN expr",
 /* 124 */ "expr ::= expr NOT IN expr",
 /* 125 */ "expr ::= NOT expr",
 /* 126 */ "expr ::= expr INCR",
 /* 127 */ "expr ::= expr DECR",
 /* 128 */ "expr ::= PARENTHESES_OPEN expr PARENTHESES_CLOSE",
 /* 129 */ "expr ::= SBRACKET_OPEN SBRACKET_CLOSE",
 /* 130 */ "expr ::= SBRACKET_OPEN array_list SBRACKET_CLOSE",
 /* 131 */ "expr ::= CBRACKET_OPEN CBRACKET_CLOSE",
 /* 132 */ "expr ::= CBRACKET_OPEN array_list CBRACKET_CLOSE",
 /* 133 */ "expr ::= expr SBRACKET_OPEN expr SBRACKET_CLOSE",
 /* 134 */ "expr ::= expr QUESTION expr COLON expr",
 /* 135 */ "expr ::= expr SBRACKET_OPEN COLON slice_offset SBRACKET_CLOSE",
 /* 136 */ "expr ::= expr SBRACKET_OPEN slice_offset COLON SBRACKET_CLOSE",
 /* 137 */ "expr ::= expr SBRACKET_OPEN slice_offset COLON slice_offset SBRACKET_CLOSE",
 /* 138 */ "slice_offset ::= INTEGER",
 /* 139 */ "slice_offset ::= IDENTIFIER",
 /* 140 */ "array_list ::= array_list COMMA array_item",
 /* 141 */ "array_list ::= array_item",
 /* 142 */ "array_item ::= STRING COLON expr",
 /* 143 */ "array_item ::= expr",
 /* 144 */ "expr ::= function_call",
 /* 145 */ "function_call ::= expr PARENTHESES_OPEN argument_list PARENTHESES_CLOSE",
 /* 146 */ "function_call ::= expr PARENTHESES_OPEN PARENTHESES_CLOSE",
 /* 147 */ "argument_list ::= argument_list COMMA argument_item",
 /* 148 */ "argument_list ::= argument_item",
 /* 149 */ "argument_item ::= expr",
 /* 150 */ "argument_item ::= STRING COLON expr",
 /* 151 */ "expr ::= IDENTIFIER",
 /* 152 */ "expr ::= INTEGER",
 /* 153 */ "expr ::= STRING",
 /* 154 */ "expr ::= DOUBLE",
 /* 155 */ "expr ::= NULL",
 /* 156 */ "expr ::= FALSE",
 /* 157 */ "expr ::= TRUE",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *phvolt_TokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to phvolt_ and phvolt_Free.
*/
void *phvolt_Alloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17:
    case 18:
    case 19:
    case 20:
    case 21:
    case 22:
    case 23:
    case 24:
    case 25:
    case 26:
    case 27:
    case 28:
    case 29:
    case 30:
    case 31:
    case 32:
    case 33:
    case 34:
    case 35:
    case 36:
    case 37:
    case 38:
    case 39:
    case 40:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
    case 47:
    case 48:
    case 49:
    case 50:
    case 51:
    case 52:
    case 53:
    case 54:
    case 55:
    case 56:
    case 57:
    case 58:
    case 59:
    case 60:
    case 61:
    case 62:
    case 63:
    case 64:
    case 65:
    case 66:
    case 67:
    case 68:
    case 69:
    case 70:
    case 71:
    case 72:
    case 73:
    case 74:
    case 75:
    case 76:
    case 77:
    case 78:
    case 79:
    case 80:
    case 81:
    case 82:
    case 83:
    case 84:
    case 85:
    case 86:
    case 87:
    case 88:
#line 158 "parser.php7.lemon"
{
	if ((yypminor->yy0)) {
		if ((yypminor->yy0)->free_flag) {
			efree((yypminor->yy0)->token);
		}
		efree((yypminor->yy0));
	}
}
#line 1229 "parser.php7.c"
      break;
    case 91:
#line 171 "parser.php7.lemon"
{
	if (&(yypminor->yy186)) {
		zval_ptr_dtor(&(yypminor->yy186));
	}
}
#line 1238 "parser.php7.c"
      break;
    case 89:
    case 90:
    case 92:
    case 93:
    case 94:
    case 95:
    case 96:
    case 97:
    case 98:
    case 99:
    case 100:
    case 101:
    case 102:
    case 103:
    case 104:
    case 105:
    case 106:
    case 107:
    case 108:
    case 109:
    case 110:
    case 111:
    case 112:
    case 113:
    case 114:
    case 115:
    case 116:
    case 117:
    case 118:
    case 119:
    case 120:
    case 121:
    case 122:
    case 123:
    case 124:
    case 125:
    case 126:
    case 127:
    case 128:
    case 129:
#line 14 "parser.php7.lemon"
{
	if (&(yypminor->yy186)) {
		zval_ptr_dtor(&(yypminor->yy186));
	}
}
#line 1286 "parser.php7.c"
      break;
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;
  yyStackEntry *yytos = &pParser->yystack[pParser->yyidx];

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yymajor = yytos->major;
  yy_destructor( yymajor, &yytos->minor);
  pParser->yyidx--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from phvolt_Alloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void phvolt_Free(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_shift_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  /* if( pParser->yyidx<0 ) return YY_NO_ACTION;  */
  i = yy_shift_ofst[stateno];
  if( i==YY_SHIFT_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
    int iFallback;            /* Fallback token */
    if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
           && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
           yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
      }
#endif
      return yy_find_shift_action(pParser, iFallback);
    }
#endif
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_reduce_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  i = yy_reduce_ofst[stateno];
  if( i==YY_REDUCE_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yyidx++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     phvolt_ARG_FETCH;
     yypParser->yyidx--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     phvolt_ARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yytos = &yypParser->yystack[yypParser->yyidx];
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 90, 1 },
  { 91, 1 },
  { 92, 2 },
  { 92, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 93, 1 },
  { 95, 8 },
  { 95, 7 },
  { 95, 12 },
  { 95, 11 },
  { 95, 10 },
  { 96, 4 },
  { 97, 3 },
  { 98, 10 },
  { 98, 12 },
  { 98, 12 },
  { 98, 14 },
  { 99, 8 },
  { 99, 7 },
  { 100, 4 },
  { 100, 3 },
  { 101, 4 },
  { 117, 3 },
  { 117, 1 },
  { 118, 3 },
  { 118, 3 },
  { 118, 3 },
  { 118, 3 },
  { 118, 3 },
  { 119, 1 },
  { 119, 4 },
  { 119, 3 },
  { 113, 10 },
  { 113, 11 },
  { 120, 3 },
  { 120, 1 },
  { 121, 1 },
  { 121, 3 },
  { 122, 1 },
  { 122, 1 },
  { 122, 1 },
  { 122, 1 },
  { 122, 1 },
  { 122, 1 },
  { 115, 11 },
  { 115, 9 },
  { 114, 2 },
  { 102, 3 },
  { 103, 8 },
  { 103, 7 },
  { 104, 8 },
  { 104, 9 },
  { 124, 1 },
  { 124, 1 },
  { 110, 7 },
  { 105, 4 },
  { 106, 4 },
  { 106, 6 },
  { 107, 4 },
  { 108, 4 },
  { 109, 8 },
  { 109, 8 },
  { 111, 3 },
  { 112, 3 },
  { 94, 1 },
  { 116, 2 },
  { 116, 2 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 4 },
  { 116, 3 },
  { 116, 4 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 3 },
  { 116, 4 },
  { 116, 2 },
  { 116, 2 },
  { 116, 2 },
  { 116, 3 },
  { 116, 2 },
  { 116, 3 },
  { 116, 2 },
  { 116, 3 },
  { 116, 4 },
  { 116, 5 },
  { 116, 5 },
  { 116, 5 },
  { 116, 6 },
  { 126, 1 },
  { 126, 1 },
  { 125, 3 },
  { 125, 1 },
  { 127, 3 },
  { 127, 1 },
  { 116, 1 },
  { 128, 4 },
  { 128, 3 },
  { 123, 3 },
  { 123, 1 },
  { 129, 1 },
  { 129, 3 },
  { 116, 1 },
  { 116, 1 },
  { 116, 1 },
  { 116, 1 },
  { 116, 1 },
  { 116, 1 },
  { 116, 1 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  phvolt_ARG_FETCH;
  yymsp = &yypParser->yystack[yypParser->yyidx];
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<sizeof(yyRuleName)/sizeof(yyRuleName[0]) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
#line 167 "parser.php7.lemon"
{
	ZVAL_ZVAL(&status->ret, &yymsp[0].minor.yy186, 1, 1);
}
#line 1661 "parser.php7.c"
        break;
      case 1:
      case 4:
      case 5:
      case 6:
      case 7:
      case 8:
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
      case 14:
      case 15:
      case 16:
      case 17:
      case 18:
      case 19:
      case 20:
      case 21:
      case 22:
      case 23:
      case 24:
      case 25:
      case 144:
#line 177 "parser.php7.lemon"
{
	yygotominor.yy186 = yymsp[0].minor.yy186;
}
#line 1691 "parser.php7.c"
        break;
      case 2:
#line 181 "parser.php7.lemon"
{
	phvolt_ret_zval_list(&yygotominor.yy186, &yymsp[-1].minor.yy186, &yymsp[0].minor.yy186);
}
#line 1698 "parser.php7.c"
        break;
      case 3:
      case 43:
      case 55:
      case 141:
      case 148:
#line 185 "parser.php7.lemon"
{
	phvolt_ret_zval_list(&yygotominor.yy186, NULL, &yymsp[0].minor.yy186);
}
#line 1709 "parser.php7.c"
        break;
      case 26:
#line 278 "parser.php7.lemon"
{
	phvolt_ret_if_statement(&yygotominor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(31,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(33,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1722 "parser.php7.c"
        break;
      case 27:
#line 283 "parser.php7.lemon"
{
	phvolt_ret_if_statement(&yygotominor.yy186, &yymsp[-4].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-6].minor);
  yy_destructor(31,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(33,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1735 "parser.php7.c"
        break;
      case 28:
#line 288 "parser.php7.lemon"
{
	phvolt_ret_if_statement(&yygotominor.yy186, &yymsp[-9].minor.yy186, &yymsp[-7].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-11].minor);
  yy_destructor(31,&yymsp[-10].minor);
  yy_destructor(32,&yymsp[-8].minor);
  yy_destructor(1,&yymsp[-6].minor);
  yy_destructor(34,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(33,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1751 "parser.php7.c"
        break;
      case 29:
#line 293 "parser.php7.lemon"
{
	phvolt_ret_if_statement(&yygotominor.yy186, &yymsp[-8].minor.yy186, &yymsp[-6].minor.yy186, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-10].minor);
  yy_destructor(31,&yymsp[-9].minor);
  yy_destructor(32,&yymsp[-7].minor);
  yy_destructor(1,&yymsp[-5].minor);
  yy_destructor(34,&yymsp[-4].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(33,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1767 "parser.php7.c"
        break;
      case 30:
#line 298 "parser.php7.lemon"
{
	phvolt_ret_if_statement(&yygotominor.yy186, &yymsp[-7].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-9].minor);
  yy_destructor(31,&yymsp[-8].minor);
  yy_destructor(32,&yymsp[-6].minor);
  yy_destructor(1,&yymsp[-5].minor);
  yy_destructor(34,&yymsp[-4].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(33,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1783 "parser.php7.c"
        break;
      case 31:
#line 302 "parser.php7.lemon"
{
	phvolt_ret_elseif_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(35,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1793 "parser.php7.c"
        break;
      case 32:
#line 306 "parser.php7.lemon"
{
	phvolt_ret_elsefor_statement(&yygotominor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(36,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1803 "parser.php7.c"
        break;
      case 33:
#line 310 "parser.php7.lemon"
{
	phvolt_ret_for_statement(&yygotominor.yy186, yymsp[-7].minor.yy0, NULL, &yymsp[-5].minor.yy186, NULL, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-9].minor);
  yy_destructor(37,&yymsp[-8].minor);
  yy_destructor(8,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(39,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1817 "parser.php7.c"
        break;
      case 34:
#line 314 "parser.php7.lemon"
{
	phvolt_ret_for_statement(&yygotominor.yy186, yymsp[-9].minor.yy0, NULL, &yymsp[-7].minor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-11].minor);
  yy_destructor(37,&yymsp[-10].minor);
  yy_destructor(8,&yymsp[-8].minor);
  yy_destructor(31,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(39,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1832 "parser.php7.c"
        break;
      case 35:
#line 318 "parser.php7.lemon"
{
	phvolt_ret_for_statement(&yygotominor.yy186, yymsp[-7].minor.yy0, yymsp[-9].minor.yy0, &yymsp[-5].minor.yy186, NULL, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-11].minor);
  yy_destructor(37,&yymsp[-10].minor);
  yy_destructor(2,&yymsp[-8].minor);
  yy_destructor(8,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(39,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1847 "parser.php7.c"
        break;
      case 36:
#line 322 "parser.php7.lemon"
{
	phvolt_ret_for_statement(&yygotominor.yy186, yymsp[-9].minor.yy0, yymsp[-11].minor.yy0, &yymsp[-7].minor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-13].minor);
  yy_destructor(37,&yymsp[-12].minor);
  yy_destructor(2,&yymsp[-10].minor);
  yy_destructor(8,&yymsp[-8].minor);
  yy_destructor(31,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(39,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1863 "parser.php7.c"
        break;
      case 37:
#line 327 "parser.php7.lemon"
{
	phvolt_ret_switch_statement(&yygotominor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(40,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(41,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1876 "parser.php7.c"
        break;
      case 38:
#line 332 "parser.php7.lemon"
{
	phvolt_ret_switch_statement(&yygotominor.yy186, &yymsp[-4].minor.yy186, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-6].minor);
  yy_destructor(40,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(41,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1889 "parser.php7.c"
        break;
      case 39:
#line 337 "parser.php7.lemon"
{
	phvolt_ret_case_clause(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(42,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1899 "parser.php7.c"
        break;
      case 40:
#line 342 "parser.php7.lemon"
{
	phvolt_ret_case_clause(&yygotominor.yy186, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(43,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1909 "parser.php7.c"
        break;
      case 41:
#line 346 "parser.php7.lemon"
{
	phvolt_ret_set_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(44,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 1919 "parser.php7.c"
        break;
      case 42:
      case 54:
      case 140:
      case 147:
#line 350 "parser.php7.lemon"
{
	phvolt_ret_zval_list(&yygotominor.yy186, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186);
  yy_destructor(2,&yymsp[-1].minor);
}
#line 1930 "parser.php7.c"
        break;
      case 44:
#line 358 "parser.php7.lemon"
{
	phvolt_ret_set_assignment(&yygotominor.yy186, &yymsp[-2].minor.yy186, PHVOLT_T_ASSIGN, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(45,&yymsp[-1].minor);
}
#line 1938 "parser.php7.c"
        break;
      case 45:
#line 362 "parser.php7.lemon"
{
	phvolt_ret_set_assignment(&yygotominor.yy186, &yymsp[-2].minor.yy186, PHVOLT_T_ADD_ASSIGN, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(46,&yymsp[-1].minor);
}
#line 1946 "parser.php7.c"
        break;
      case 46:
#line 366 "parser.php7.lemon"
{
	phvolt_ret_set_assignment(&yygotominor.yy186, &yymsp[-2].minor.yy186, PHVOLT_T_SUB_ASSIGN, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(47,&yymsp[-1].minor);
}
#line 1954 "parser.php7.c"
        break;
      case 47:
#line 370 "parser.php7.lemon"
{
	phvolt_ret_set_assignment(&yygotominor.yy186, &yymsp[-2].minor.yy186, PHVOLT_T_MUL_ASSIGN, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(48,&yymsp[-1].minor);
}
#line 1962 "parser.php7.c"
        break;
      case 48:
#line 374 "parser.php7.lemon"
{
	phvolt_ret_set_assignment(&yygotominor.yy186, &yymsp[-2].minor.yy186, PHVOLT_T_DIV_ASSIGN, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(49,&yymsp[-1].minor);
}
#line 1970 "parser.php7.c"
        break;
      case 49:
      case 73:
      case 139:
      case 151:
#line 378 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_IDENTIFIER, yymsp[0].minor.yy0, status->scanner_state);
}
#line 1980 "parser.php7.c"
        break;
      case 50:
      case 133:
#line 382 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ARRAYACCESS, &yymsp[-3].minor.yy186, &yymsp[-1].minor.yy186, NULL, status->scanner_state);
  yy_destructor(24,&yymsp[-2].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 1990 "parser.php7.c"
        break;
      case 51:
      case 122:
#line 386 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_DOT, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(30,&yymsp[-1].minor);
}
#line 1999 "parser.php7.c"
        break;
      case 52:
#line 390 "parser.php7.lemon"
{
	phvolt_ret_macro_statement(&yygotominor.yy186, yymsp[-7].minor.yy0, NULL, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-9].minor);
  yy_destructor(51,&yymsp[-8].minor);
  yy_destructor(29,&yymsp[-6].minor);
  yy_destructor(52,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(53,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2014 "parser.php7.c"
        break;
      case 53:
#line 394 "parser.php7.lemon"
{
	phvolt_ret_macro_statement(&yygotominor.yy186, yymsp[-8].minor.yy0, &yymsp[-6].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-10].minor);
  yy_destructor(51,&yymsp[-9].minor);
  yy_destructor(29,&yymsp[-7].minor);
  yy_destructor(52,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(53,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2029 "parser.php7.c"
        break;
      case 56:
#line 406 "parser.php7.lemon"
{
	phvolt_ret_macro_parameter(&yygotominor.yy186, yymsp[0].minor.yy0, NULL, status->scanner_state);
}
#line 2036 "parser.php7.c"
        break;
      case 57:
#line 410 "parser.php7.lemon"
{
	phvolt_ret_macro_parameter(&yygotominor.yy186, yymsp[-2].minor.yy0, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(45,&yymsp[-1].minor);
}
#line 2044 "parser.php7.c"
        break;
      case 58:
      case 72:
      case 138:
      case 152:
#line 414 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_INTEGER, yymsp[0].minor.yy0, status->scanner_state);
}
#line 2054 "parser.php7.c"
        break;
      case 59:
      case 153:
#line 418 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_STRING, yymsp[0].minor.yy0, status->scanner_state);
}
#line 2062 "parser.php7.c"
        break;
      case 60:
      case 154:
#line 422 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_DOUBLE, yymsp[0].minor.yy0, status->scanner_state);
}
#line 2070 "parser.php7.c"
        break;
      case 61:
      case 155:
#line 426 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_NULL, NULL, status->scanner_state);
  yy_destructor(57,&yymsp[0].minor);
}
#line 2079 "parser.php7.c"
        break;
      case 62:
      case 156:
#line 430 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_FALSE, NULL, status->scanner_state);
  yy_destructor(58,&yymsp[0].minor);
}
#line 2088 "parser.php7.c"
        break;
      case 63:
      case 157:
#line 434 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_TRUE, NULL, status->scanner_state);
  yy_destructor(59,&yymsp[0].minor);
}
#line 2097 "parser.php7.c"
        break;
      case 64:
#line 438 "parser.php7.lemon"
{
	phvolt_ret_macro_call_statement(&yygotominor.yy186, &yymsp[-8].minor.yy186, &yymsp[-6].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-10].minor);
  yy_destructor(60,&yymsp[-9].minor);
  yy_destructor(29,&yymsp[-7].minor);
  yy_destructor(52,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(61,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2112 "parser.php7.c"
        break;
      case 65:
#line 442 "parser.php7.lemon"
{
	phvolt_ret_macro_call_statement(&yygotominor.yy186, &yymsp[-6].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-8].minor);
  yy_destructor(60,&yymsp[-7].minor);
  yy_destructor(29,&yymsp[-5].minor);
  yy_destructor(52,&yymsp[-4].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(61,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2127 "parser.php7.c"
        break;
      case 66:
#line 446 "parser.php7.lemon"
{
	phvolt_ret_empty_statement(&yygotominor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2136 "parser.php7.c"
        break;
      case 67:
#line 450 "parser.php7.lemon"
{
	phvolt_ret_echo_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(62,&yymsp[-2].minor);
  yy_destructor(63,&yymsp[0].minor);
}
#line 2145 "parser.php7.c"
        break;
      case 68:
#line 454 "parser.php7.lemon"
{
	phvolt_ret_block_statement(&yygotominor.yy186, yymsp[-5].minor.yy0, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(64,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(65,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2158 "parser.php7.c"
        break;
      case 69:
#line 458 "parser.php7.lemon"
{
	phvolt_ret_block_statement(&yygotominor.yy186, yymsp[-4].minor.yy0, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-6].minor);
  yy_destructor(64,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-3].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(65,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2171 "parser.php7.c"
        break;
      case 70:
#line 462 "parser.php7.lemon"
{
	phvolt_ret_cache_statement(&yygotominor.yy186, &yymsp[-5].minor.yy186, NULL, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(66,&yymsp[-6].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(67,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2184 "parser.php7.c"
        break;
      case 71:
#line 466 "parser.php7.lemon"
{
	phvolt_ret_cache_statement(&yygotominor.yy186, &yymsp[-6].minor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-8].minor);
  yy_destructor(66,&yymsp[-7].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(67,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2197 "parser.php7.c"
        break;
      case 74:
#line 478 "parser.php7.lemon"
{
	phvolt_ret_raw_statement(&yygotominor.yy186, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-6].minor);
  yy_destructor(68,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(69,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2210 "parser.php7.c"
        break;
      case 75:
#line 482 "parser.php7.lemon"
{
	phvolt_ret_extends_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(70,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2220 "parser.php7.c"
        break;
      case 76:
#line 486 "parser.php7.lemon"
{
	phvolt_ret_include_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, NULL, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(71,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2230 "parser.php7.c"
        break;
      case 77:
#line 490 "parser.php7.lemon"
{
	phvolt_ret_include_statement(&yygotominor.yy186, &yymsp[-3].minor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-5].minor);
  yy_destructor(71,&yymsp[-4].minor);
  yy_destructor(72,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2241 "parser.php7.c"
        break;
      case 78:
#line 494 "parser.php7.lemon"
{
	phvolt_ret_do_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(73,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2251 "parser.php7.c"
        break;
      case 79:
#line 498 "parser.php7.lemon"
{
	phvolt_ret_return_statement(&yygotominor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-3].minor);
  yy_destructor(74,&yymsp[-2].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2261 "parser.php7.c"
        break;
      case 80:
#line 502 "parser.php7.lemon"
{
	phvolt_ret_autoescape_statement(&yygotominor.yy186, 0, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(75,&yymsp[-6].minor);
  yy_destructor(58,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(76,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2275 "parser.php7.c"
        break;
      case 81:
#line 506 "parser.php7.lemon"
{
	phvolt_ret_autoescape_statement(&yygotominor.yy186, 1, &yymsp[-3].minor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-7].minor);
  yy_destructor(75,&yymsp[-6].minor);
  yy_destructor(59,&yymsp[-5].minor);
  yy_destructor(32,&yymsp[-4].minor);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(76,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2289 "parser.php7.c"
        break;
      case 82:
#line 510 "parser.php7.lemon"
{
	phvolt_ret_break_statement(&yygotominor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(77,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2299 "parser.php7.c"
        break;
      case 83:
#line 514 "parser.php7.lemon"
{
	phvolt_ret_continue_statement(&yygotominor.yy186, status->scanner_state);
  yy_destructor(1,&yymsp[-2].minor);
  yy_destructor(78,&yymsp[-1].minor);
  yy_destructor(32,&yymsp[0].minor);
}
#line 2309 "parser.php7.c"
        break;
      case 84:
#line 518 "parser.php7.lemon"
{
	phvolt_ret_literal_zval(&yygotominor.yy186, PHVOLT_T_RAW_FRAGMENT, yymsp[0].minor.yy0, status->scanner_state);
}
#line 2316 "parser.php7.c"
        break;
      case 85:
#line 522 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_MINUS, NULL, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(22,&yymsp[-1].minor);
}
#line 2324 "parser.php7.c"
        break;
      case 86:
#line 526 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_PLUS, NULL, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(21,&yymsp[-1].minor);
}
#line 2332 "parser.php7.c"
        break;
      case 87:
#line 530 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_SUB, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(22,&yymsp[-1].minor);
}
#line 2340 "parser.php7.c"
        break;
      case 88:
#line 534 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ADD, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(21,&yymsp[-1].minor);
}
#line 2348 "parser.php7.c"
        break;
      case 89:
#line 538 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_MUL, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(19,&yymsp[-1].minor);
}
#line 2356 "parser.php7.c"
        break;
      case 90:
#line 542 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_POW, &yymsp[-3].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(19,&yymsp[-2].minor);
  yy_destructor(19,&yymsp[-1].minor);
}
#line 2365 "parser.php7.c"
        break;
      case 91:
#line 546 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_DIV, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(18,&yymsp[-1].minor);
}
#line 2373 "parser.php7.c"
        break;
      case 92:
#line 550 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_MOD, &yymsp[-3].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(18,&yymsp[-2].minor);
  yy_destructor(18,&yymsp[-1].minor);
}
#line 2382 "parser.php7.c"
        break;
      case 93:
#line 554 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_MOD, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(20,&yymsp[-1].minor);
}
#line 2390 "parser.php7.c"
        break;
      case 94:
#line 558 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_AND, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(6,&yymsp[-1].minor);
}
#line 2398 "parser.php7.c"
        break;
      case 95:
#line 562 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_OR, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(7,&yymsp[-1].minor);
}
#line 2406 "parser.php7.c"
        break;
      case 96:
#line 566 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_CONCAT, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(23,&yymsp[-1].minor);
}
#line 2414 "parser.php7.c"
        break;
      case 97:
#line 570 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_PIPE, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(25,&yymsp[-1].minor);
}
#line 2422 "parser.php7.c"
        break;
      case 98:
#line 574 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_RANGE, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(5,&yymsp[-1].minor);
}
#line 2430 "parser.php7.c"
        break;
      case 99:
#line 578 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_EQUALS, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(10,&yymsp[-1].minor);
}
#line 2438 "parser.php7.c"
        break;
      case 100:
#line 582 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISSET, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(80,&yymsp[0].minor);
}
#line 2447 "parser.php7.c"
        break;
      case 101:
#line 586 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISSET, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(80,&yymsp[0].minor);
}
#line 2456 "parser.php7.c"
        break;
      case 102:
#line 590 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISEMPTY, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(81,&yymsp[0].minor);
}
#line 2465 "parser.php7.c"
        break;
      case 103:
#line 594 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISEMPTY, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(81,&yymsp[0].minor);
}
#line 2474 "parser.php7.c"
        break;
      case 104:
#line 598 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISEVEN, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(82,&yymsp[0].minor);
}
#line 2483 "parser.php7.c"
        break;
      case 105:
#line 602 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISEVEN, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(82,&yymsp[0].minor);
}
#line 2492 "parser.php7.c"
        break;
      case 106:
#line 606 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISODD, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(83,&yymsp[0].minor);
}
#line 2501 "parser.php7.c"
        break;
      case 107:
#line 610 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISODD, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(83,&yymsp[0].minor);
}
#line 2510 "parser.php7.c"
        break;
      case 108:
#line 614 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISNUMERIC, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(84,&yymsp[0].minor);
}
#line 2519 "parser.php7.c"
        break;
      case 109:
#line 618 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISNUMERIC, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(84,&yymsp[0].minor);
}
#line 2528 "parser.php7.c"
        break;
      case 110:
#line 622 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISSCALAR, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(85,&yymsp[0].minor);
}
#line 2537 "parser.php7.c"
        break;
      case 111:
#line 626 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISSCALAR, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(85,&yymsp[0].minor);
}
#line 2546 "parser.php7.c"
        break;
      case 112:
#line 630 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_ISITERABLE, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
  yy_destructor(86,&yymsp[0].minor);
}
#line 2555 "parser.php7.c"
        break;
      case 113:
#line 634 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ISITERABLE, &yymsp[-2].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
  yy_destructor(86,&yymsp[0].minor);
}
#line 2564 "parser.php7.c"
        break;
      case 114:
#line 638 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_IS, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(9,&yymsp[-1].minor);
}
#line 2572 "parser.php7.c"
        break;
      case 115:
#line 642 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOTEQUALS, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(11,&yymsp[-1].minor);
}
#line 2580 "parser.php7.c"
        break;
      case 116:
#line 646 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_IDENTICAL, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(16,&yymsp[-1].minor);
}
#line 2588 "parser.php7.c"
        break;
      case 117:
#line 650 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOTIDENTICAL, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(17,&yymsp[-1].minor);
}
#line 2596 "parser.php7.c"
        break;
      case 118:
#line 654 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_LESS, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(12,&yymsp[-1].minor);
}
#line 2604 "parser.php7.c"
        break;
      case 119:
#line 658 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_GREATER, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(13,&yymsp[-1].minor);
}
#line 2612 "parser.php7.c"
        break;
      case 120:
#line 662 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_GREATEREQUAL, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(14,&yymsp[-1].minor);
}
#line 2620 "parser.php7.c"
        break;
      case 121:
#line 666 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_LESSEQUAL, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(15,&yymsp[-1].minor);
}
#line 2628 "parser.php7.c"
        break;
      case 123:
#line 674 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_IN, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(8,&yymsp[-1].minor);
}
#line 2636 "parser.php7.c"
        break;
      case 124:
#line 678 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT_IN, &yymsp[-3].minor.yy186, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(26,&yymsp[-2].minor);
  yy_destructor(8,&yymsp[-1].minor);
}
#line 2645 "parser.php7.c"
        break;
      case 125:
#line 682 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_NOT, NULL, &yymsp[0].minor.yy186, NULL, status->scanner_state);
  yy_destructor(26,&yymsp[-1].minor);
}
#line 2653 "parser.php7.c"
        break;
      case 126:
#line 686 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_INCR, &yymsp[-1].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(27,&yymsp[0].minor);
}
#line 2661 "parser.php7.c"
        break;
      case 127:
#line 690 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_DECR, &yymsp[-1].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(28,&yymsp[0].minor);
}
#line 2669 "parser.php7.c"
        break;
      case 128:
#line 694 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ENCLOSED, &yymsp[-1].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(29,&yymsp[-2].minor);
  yy_destructor(52,&yymsp[0].minor);
}
#line 2678 "parser.php7.c"
        break;
      case 129:
#line 698 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ARRAY, NULL, NULL, NULL, status->scanner_state);
  yy_destructor(24,&yymsp[-1].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 2687 "parser.php7.c"
        break;
      case 130:
#line 702 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ARRAY, &yymsp[-1].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(24,&yymsp[-2].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 2696 "parser.php7.c"
        break;
      case 131:
#line 706 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ARRAY, NULL, NULL, NULL, status->scanner_state);
  yy_destructor(87,&yymsp[-1].minor);
  yy_destructor(88,&yymsp[0].minor);
}
#line 2705 "parser.php7.c"
        break;
      case 132:
#line 710 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_ARRAY, &yymsp[-1].minor.yy186, NULL, NULL, status->scanner_state);
  yy_destructor(87,&yymsp[-2].minor);
  yy_destructor(88,&yymsp[0].minor);
}
#line 2714 "parser.php7.c"
        break;
      case 134:
#line 718 "parser.php7.lemon"
{
	phvolt_ret_expr(&yygotominor.yy186, PHVOLT_T_TERNARY, &yymsp[-2].minor.yy186, &yymsp[0].minor.yy186, &yymsp[-4].minor.yy186, status->scanner_state);
  yy_destructor(3,&yymsp[-3].minor);
  yy_destructor(4,&yymsp[-1].minor);
}
#line 2723 "parser.php7.c"
        break;
      case 135:
#line 722 "parser.php7.lemon"
{
	phvolt_ret_slice(&yygotominor.yy186, &yymsp[-4].minor.yy186, NULL, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(24,&yymsp[-3].minor);
  yy_destructor(4,&yymsp[-2].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 2733 "parser.php7.c"
        break;
      case 136:
#line 726 "parser.php7.lemon"
{
	phvolt_ret_slice(&yygotominor.yy186, &yymsp[-4].minor.yy186, &yymsp[-2].minor.yy186, NULL, status->scanner_state);
  yy_destructor(24,&yymsp[-3].minor);
  yy_destructor(4,&yymsp[-1].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 2743 "parser.php7.c"
        break;
      case 137:
#line 730 "parser.php7.lemon"
{
	phvolt_ret_slice(&yygotominor.yy186, &yymsp[-5].minor.yy186, &yymsp[-3].minor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(24,&yymsp[-4].minor);
  yy_destructor(4,&yymsp[-2].minor);
  yy_destructor(50,&yymsp[0].minor);
}
#line 2753 "parser.php7.c"
        break;
      case 142:
      case 150:
#line 750 "parser.php7.lemon"
{
	phvolt_ret_named_item(&yygotominor.yy186, yymsp[-2].minor.yy0, &yymsp[0].minor.yy186, status->scanner_state);
  yy_destructor(4,&yymsp[-1].minor);
}
#line 2762 "parser.php7.c"
        break;
      case 143:
      case 149:
#line 754 "parser.php7.lemon"
{
	phvolt_ret_named_item(&yygotominor.yy186, NULL, &yymsp[0].minor.yy186, status->scanner_state);
}
#line 2770 "parser.php7.c"
        break;
      case 145:
#line 762 "parser.php7.lemon"
{
	phvolt_ret_func_call(&yygotominor.yy186, &yymsp[-3].minor.yy186, &yymsp[-1].minor.yy186, status->scanner_state);
  yy_destructor(29,&yymsp[-2].minor);
  yy_destructor(52,&yymsp[0].minor);
}
#line 2779 "parser.php7.c"
        break;
      case 146:
#line 766 "parser.php7.lemon"
{
	phvolt_ret_func_call(&yygotominor.yy186, &yymsp[-2].minor.yy186, NULL, status->scanner_state);
  yy_destructor(29,&yymsp[-1].minor);
  yy_destructor(52,&yymsp[0].minor);
}
#line 2788 "parser.php7.c"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yyact = yy_find_reduce_action(yypParser,yygoto);
  if( yyact < YYNSTATE ){
    yy_shift(yypParser,yyact,yygoto,&yygotominor);
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  phvolt_ARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  phvolt_ARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  phvolt_ARG_FETCH;
#define TOKEN (yyminor.yy0)
#line 54 "parser.php7.lemon"

	{
		smart_str error_str = {0};

		char *token_name = NULL;
		const phvolt_token_names *tokens = phvolt_tokens;
		int token_len = 0;
		int active_token = status->scanner_state->active_token;

		if (status->scanner_state->start_length) {

			if (active_token) {

				do {
					if (tokens->code == active_token) {
						token_name = tokens->name;
						token_len = tokens->len;
						break;
					}
					++tokens;
				} while (tokens[0].code != 0);

			}

			smart_str_appendl(&error_str, "Syntax error, unexpected token ", sizeof("Syntax error, unexpected token ") - 1);
			if (!token_name) {
				smart_str_appendl(&error_str, "UNKNOWN", sizeof("UNKNOWN") - 1);
			} else {
				smart_str_appendl(&error_str, token_name, token_len);
			}

			if (status->token->value) {
				smart_str_appendc(&error_str, '(');
				smart_str_appendl(&error_str, status->token->value, status->token->len);
				smart_str_appendc(&error_str, ')');
			}

			smart_str_appendl(&error_str, " in ", sizeof(" in ") - 1);
			smart_str_appendl(&error_str, Z_STRVAL_P(status->scanner_state->active_file), Z_STRLEN_P(status->scanner_state->active_file));
			smart_str_appendl(&error_str, " on line ", sizeof(" on line ") - 1);

			{
				char stmp[MAX_LENGTH_OF_LONG + 1];
				int str_len;
				str_len = slprintf(stmp, sizeof(stmp), "%u", status->scanner_state->active_line);
				smart_str_appendl(&error_str, stmp, str_len);
			}

		} else {

			smart_str_appendl(&error_str, "Syntax error, unexpected EOF in ", sizeof("Syntax error, unexpected EOF in ") - 1);
			smart_str_appendl(&error_str, Z_STRVAL_P(status->scanner_state->active_file), Z_STRLEN_P(status->scanner_state->active_file));

			/* Report unclosed 'if' blocks */
			if ((status->scanner_state->if_level + status->scanner_state->old_if_level) > 0) {
				if ((status->scanner_state->if_level + status->scanner_state->old_if_level) == 1) {
					smart_str_appendl(&error_str, ", there is one 'if' block without close", sizeof(", there is one 'if' block without close") - 1);
				} else {
					smart_str_appendl(&error_str, ", there are ", sizeof(", there are ") - 1);
					{
						char stmp[MAX_LENGTH_OF_LONG + 1];
						int str_len;
						str_len = slprintf(stmp, sizeof(stmp), "%u", status->scanner_state->if_level + status->scanner_state->old_if_level);
						smart_str_appendl(&error_str, stmp, str_len);
					}
					smart_str_appendl(&error_str, " 'if' blocks without close", sizeof(" 'if' blocks without close") - 1);
				}
			}

			/* Report unclosed 'for' blocks */
			if (status->scanner_state->for_level > 0) {
				if (status->scanner_state->for_level == 1) {
					smart_str_appendl(&error_str, ", there is one 'for' block without close", sizeof(", there is one 'for' block without close") - 1);
				} else {
					smart_str_appendl(&error_str, ", there are ", sizeof(", there are ") - 1);
					{
						char stmp[MAX_LENGTH_OF_LONG + 1];
						int str_len;
						str_len = slprintf(stmp, sizeof(stmp), "%u", status->scanner_state->if_level);
						smart_str_appendl(&error_str, stmp, str_len);
					}
					smart_str_appendl(&error_str, " 'for' blocks without close", sizeof(" 'for' blocks without close") - 1);
				}
			}

			/* Report unclosed 'switch' blocks */
			if (status->scanner_state->switch_level > 0) {
				smart_str_appendl(&error_str, ", there is a 'switch' block without 'endswitch'", sizeof(", there is a 'switch' block without 'endswitch'") - 1);
			}
		}

		smart_str_0(&error_str);

		if (error_str.s) {
			status->syntax_error = estrndup(ZSTR_VAL(error_str.s), ZSTR_LEN(error_str.s));
			status->syntax_error_len = ZSTR_LEN(error_str.s);
		} else {
			status->syntax_error = NULL;
		}
	}

	status->status = PHVOLT_PARSING_FAILED;

#line 2934 "parser.php7.c"
  phvolt_ARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  phvolt_ARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  phvolt_ARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "phvolt_Alloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void phvolt_(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  phvolt_TOKENTYPE yyminor       /* The value for the token */
  phvolt_ARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    if( yymajor==0 ) return;
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yystack[0].stateno = 0;
    yypParser->yystack[0].major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  phvolt_ARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_shift_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
      int yymx;
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yymx = yypParser->yystack[yypParser->yyidx].major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yymx != YYERRORSYMBOL &&
          (yyact = yy_find_shift_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
