<?php

/**
 * This file is part of the Phalcon Framework.
 *
 * (c) Phalcon Team <team@phalcon.io>
 *
 * For the full copyright and license information, please view the LICENSE.txt
 * file that was distributed with this source code.
 */

declare(strict_types=1);

namespace Phalcon\Test\Database\Mvc\Model\Criteria;

use DatabaseTester;
use Phalcon\Mvc\Model\Criteria;
use Phalcon\Test\Fixtures\Traits\DiTrait;

/**
 * Class CacheCest
 */
class CacheCest
{
    use DiTrait;

    public function _before(DatabaseTester $I)
    {
        $this->setNewFactoryDefault();
    }

    /**
     * Tests Phalcon\Mvc\Model\Criteria :: cache()
     *
     * @author Phalcon Team <team@phalcon.io>
     * @since  2020-02-01
     *
     * @group  common
     */
    public function mvcModelCriteriaCache(DatabaseTester $I)
    {
        $I->wantToTest('Mvc\Model\Criteria - cache()');

        $criteria = new Criteria();
        $criteria->setDI($this->container);

        $options = [
            'lifetime' => 120,
        ];
        $criteria->cache($options);

        $actual = $criteria->getParams();

        $I->assertEquals($options, $actual['cache']);
    }
}
